****************************************************************************
** PROCEDIMIENTO GENERAL DE CONTRATACIONES
****************************************************************************
PROCEDURE contratacion()
DO WHILE .T.
   indices()
   USE catprin INDEX indprin NEW
   USE sol_pers INDEX indsol NEW
   SET COLOR TO "W+/BG+,B+/W"
   DO WHILE .T.
      limpiamenu(2,1,22,79)
      barstatus(4)
      vfolio=sel_folio()
      IF vfolio=NIL
         CLOSE ALL
         RETURN
      ELSE
         clave_puesto=busca_datos_req(vfolio)
         resp = dialogo("Contratacin p/este puesto? S/N")
         IF resp="S"
            USE sol_pers INDEX indsol NEW
            USE catprin INDEX indprin NEW
            SELECT sol_pers
            SEEK vfolio 
            var_area = clave_area
            continua = .T.
            EXIT
         ELSE
            limpiamenu(5,15,23,79)
            continua = .F.
            EXIT
         ENDIF
      ENDIF
   ENDDO
   IF continua = .T.
      barstatus(13)
      USE selfin NEW
      USE selfin2 NEW
      resp = "N"
      DO WHILE resp = "N"
         * F2 para catlogo de candidatos seleccionados
         SETKEY(-1,{||muestra_gral(4,3,19,76,vfolio,LASTKEY())})      
         * F3 para catlogo de trabajadores promocionados
         SETKEY(-2,{||muestra2_gral(4,3,19,76,vfolio,LASTKEY())})      
         varclave_p = SPACE(8)
         clave = SPACE(8)
         @16,15 SAY "Persona a contratar: " GET clave PICTURE "@!" VALID .NOT. clave=" "
         READ
         IF LASTKEY()=27
            limpiamenu(1,1,23,79)
            SETKEY()
            resp = "S"
            EXIT
         ELSE
            resp=dialogo("Es correcta la seleccin? S/N")
            IF resp = "S"
               SETKEY()
               varclave_p = clave
               SELECT selfin
               LOCATE FOR cve_per = varclave_p 
               IF .NOT. FOUND()
                  SELECT selfin2
                  LOCATE FOR cve_per = varclave_p
                  IF .NOT. FOUND()
                     ponerror("Clave inexistente") 
                     resp = "N"
                  ELSE
                     base = "selfin2"
                     tipo_per = "W"
                  ENDIF
               ELSE
                  base = "selfin"
                  tipo_per = "K"
               ENDIF
               resul = datos_contrata(base,clave_puesto,var_area,vfolio,varclave_p,tipo_per,"A")     
               IF resul = .F.
                  resp = "S"
               ENDIF
            ENDIF
         ENDIF
      ENDDO
   ENDIF
   CLOSE ALL
ENDDO

**********************************************************************
* FUNCION PARA INTRODUCIR LOS DATOS DE LA CONTRATACION
**********************************************************************
FUNCTION datos_contrata(base,clave_puesto,var_area,vfolio,varclave_p,tipo_per,tipo_man)

USE plantill INDEX indplant NEW
USE nombres NEW
DO WHILE .T.
   barstatus(7)
   SET COLOR TO W/BG+,B+/W
   marcmenu(2,1,20,77)
   SET COLOR TO W/BG+,B+/W
   STORE SPACE(8) TO clave
   inivar_cont(tipo_man,varclave_p,clave_puesto,var_area)
   resp2="N"
   vcve_per = SPACE(8)
   * vcve_per = varclave_p
   DO WHILE resp2="N"
      SET COLOR TO "W+/BG+,B+/W"
      SELECT nombres
      LOCATE FOR cve_per = varclave_p
      IF tipo = tipo_per
         persona = TRIM(nombre_s) + " " + TRIM(paterno) + " " + TRIM(materno)
         @3,3 SAY "Nombre: " + persona
         @5,3 SAY "Clave trabajador: " GET vcve_per PICTURE "@!" VALID .NOT. vcve_per = " "
         @7,3 SAY "Num. Afil. S.S.: " GET vnum_af_ss PICTURE "@!"
         @9,2 SAY "-- DATOS CONTRATO " + REPLICATE("-",57)
         SELECT catprin
         SEEK vcve_puest
         @11,3 SAY "Puesto: " + vcve_puest + " " + nom_obj
         SEEK vcve_area
         @13,3 SAY "Area: " + vcve_area + nom_obj
         @15,3 SAY "Sueldo: $ " GET vsueldo PICTURE "99999.99" VALID .NOT. vsueldo = 0
         @15,40 SAY "Horario: " GET vhorario PICTURE "99:99-99:99" VALID .NOT. vhorario = " "
         SETKEY(-1,{||cat_gral(6,3,20,56,"catprin","Q")})     
         @17,3 SAY "Tipo de contratacin: " GET clave PICTURE "@!" VALID .NOT. clave = " "
         READ
         IF LASTKEY()=27
            limpiamenu(2,1,22,80)
            SETKEY()
            resp = "N"
            RETURN(.F.)
         ELSE
            vtipo_cont = clave
            SETKEY()
            SELECT catprin
            SEEK vtipo_cont
            @17,40 SAY TRIM(nom_obj)
            pandial = SAVESCREEN(17,30,21,79)
            resp2=dialogo("Es correcto? S/N ")
            IF resp2="S"
               RESTSCREEN(17,30,21,79,pandial)
               valdat = valida_datos(vcve_per,vcve_puest,vsueldo)
               IF valdat = .T.
                  alma_dat_cont(base,vfolio,vcve_per,varclave_p,tipo_per)
                  limpiamenu(2,1,22,79)
                  RETURN(.T.)
               ELSE
                  resp2 = "N"
               ENDIF   
            ENDIF
         ENDIF
      ELSE
         ponerror("Persona inexistente")
         resp2 = "N"
         RETURN(.F.)
      ENDIF 
   ENDDO
ENDDO
CLOSE nombres
CLOSE plantill

************************************************************************
* PROCEDIMIENTO PARA INICIALIZAR LAS VARIABLES DE CONTRATACION
************************************************************************
PROCEDURE inivar_cont(tipo_man,varclave_p,clave_puesto,var_area)

PUBLIC vcve_per
PUBLIC vcve_puest
PUBLIC vcve_area
PUBLIC vsueldo
PUBLIC vhorario
PUBLIC vnum_af_ss
PUBLIC vtipo_cont
**** Inicializando las variables por primera vez
STORE 0 TO vsueldo
STORE SPACE(11) TO vhorario
STORE SPACE(21) TO vnum_af_ss
STORE SPACE(8) TO vtipo_cont
STORE clave_puesto TO vcve_puest
STORE var_area TO vcve_area


************************************************************************
* PROCEDIMIENTO PARA GUARDAR LOS DATOS DE CONTRATACION
************************************************************************
PROCEDURE alma_dat_cont(base,vfolio,vcve_per,varclave_p,tipo_per)

*** Dando de alta en la plantilla
SELECT plantill
IF tipo_per = "K"
   APPEND BLANK
ELSE 
   SEEK vcve_per
ENDIF
num_campos=FCOUNT()
FOR cont_campo=1 to num_campos
    nom_campo=FIELD(cont_campo)
    vnom_campo="V"+FIELD(cont_campo)
    REPLACE &nom_campo WITH &vnom_campo
NEXT
*** Actualizando clave de trabajador en tabla de nombres
SELECT nombres 
    LOCATE FOR cve_per = varclave_p
    REPLACE tipo WITH "W"
    REPLACE cve_per WITH vcve_per
*** Actualizando clave de trabajador en tabla de direcciones
USE direc NEW
    LOCATE FOR cve_per = varclave_p
    REPLACE tipo WITH "W"
    REPLACE cve_per WITH vcve_per
CLOSE direc
*** Actualizando clave de trabajador en tabla de datos personales
USE datos_pe NEW
    LOCATE FOR cve_per = varclave_p
    REPLACE tipo WITH "W"
    REPLACE cve_per WITH vcve_per
CLOSE datos_pe
*** Eliminandolo de la base de seleccionados
SELECT &base
  SET FILTER TO cve_per = varclave_p
  DELETE ALL
  PACK
  SET FILTER TO
*** Eliminandolo de la base de candidatos
USE candidat INDEX indcandi
  SEEK varclave_p
  num_reg = RECNO()
  GOTO num_reg
  DELETE
  PACK
  CLOSE candidat
*** Cambiando la clave en la asignacin de especificaciones
USE asig_esp INDEX indasige
  GO TOP
  DO WHILE !EOF()
     SEEK varclave_p
     REPLACE tipo WITH "W"
     REPLACE cve_per WITH vcve_per
     SKIP
  ENDDO
CLOSE asig_esp
*** Restando en uno el requerimiento de personal
SELECT sol_pers
  SEEK vfolio
  num_reg = RECNO()
  num_per = per_requer
  num_per = num_per - 1
  IF num_per = 0
     GO num_reg
     DELETE
     PACK
  ELSE
     REPLACE per_requer WITH num_per
  ENDIF
*** Creando su historial de puestos
USE trabpues NEW
  APPEND BLANK
  REPLACE cve_per WITH vcve_per
  REPLACE cve_puest WITH vcve_puest
  REPLACE fec_ing_pu WITH DATE()
  REPLACE sueldo_bru WITH vsueldo
  CLOSE trabpues
SELECT id_pues
  SEEK vcve_puest
  REPLACE plaza_ocup WITH plaza_ocup + 1
  CLOSE id_pues
RETURN

*************************************************************************
*** FUNCION QUE VALIDA QUE LOS DATOS DE LA CONTRATACION ESTEN DE ACUERDO
*** A LA IDENTIFICACION DEL PUESTO QUE SE ESTA CONTRATANDO
*************************************************************************
FUNCTION valida_datos(vcve_per,vcve_puest,vsueldo)

validacion = .T.
USE id_pues INDEX indidpue NEW
USE cat_tabu INDEX indcatab NEW
SELECT plantill
   SEEK vcve_per
   IF FOUND()
      ponerror("Clave trabajador existente")
      validacion = .F.
   ENDIF 
SELECT id_pues
   SEEK vcve_puest
   v1tab_mi = clv_tab_mi
   v2tab_ma = clv_tab_ma
   vplaza_exis = plaza_exis
   vplaza_ocup = plaza_ocup
SELECT cat_tabu
   SET FILTER TO
   SEEK v1tab_mi
       vmontomi = monto_tab
   SEEK v2tab_ma
       vmontoma = monto_tab
IF vsueldo < vmontomi 
   ponerror("Sueldo inferior al permitido")
   validacion = .F.
ELSE 
   IF vsueldo > vmontoma
      ponerror("Sueldo superior al permitido")
      validacion = .F.
   ENDIF
ENDIF
CLOSE cat_tabu
IF vplaza_exis = vplaza_ocup 
   ponerror ("Puesto sin plazas disponibles")
   validacion = .F.
ENDIF
RETURN(validacion)
