*PROCEDIMIENTO PARA DAR DE ALTA ESPECIFICACIONES
PROCEDURE asig_espe(base,vtipo,texto_tipo,acc1,acc2)

PRIVATE clave

band_cve = .F.
DO WHILE .T.
   barstatus(7)
   SET ESCAPE ON
   DO WHILE band_cve = .F.
      SET COLOR TO W/BG+,B+/W
      IF base="catprin"
         SETKEY(-1,{||cat_gral(6,3,20,56,"catprin",@vtipo)})
      ELSE
         SETKEY(-1,{||cat_gral(6,3,20,56,"nombres",@vtipo)})      
      ENDIF
      clave:=cve_tipo:=SPACE(8)
      @2,5 SAY "Clave: " GET clave PICT "@!" VALID .NOT. clave=" "
      READ
      IF LASTKEY()=27
         RETURN
      ELSE
         cve_tipo=clave
         band_cve=saca_tipo(base,cve_tipo,texto_tipo,2,25)
      ENDIF
   ENDDO
   band_cve=.F.
   DO WHILE band_cve = .F.
      SELECT catprin
      SETKEY(-1,{||desprubros("S",6,1,13,54)})
      clave:=cve_sub:=SPACE(8)
      limpiamenu(4,5,4,79)
      SET COLOR TO W+/BG+,B+/W
      @4,5 SAY "Clave Subesp.: " GET clave PICT "@!" VALID .NOT. clave=" "
      READ
      IF LASTKEY()=27
        limpiamenu(2,1,5,79)
        EXIT
      ELSE
         cve_sub=clave
         band_cve=saca_tipo("catprin",cve_sub,"Nombre",4,35)
      ENDIF
      IF band_cve = .T.
         SELECT asig_esp
         DBREINDEX()
         SEEK cve_tipo+cve_sub
         IF FOUND()
            ponerror("La especificacin ya fue asignada")
            limpiamenu(4,5,4,79)
            SET COLOR TO W+/BG+,B+/W
            band_cve=.F.
         ELSE
            asigvalor(cve_tipo,cve_sub,acc1,acc2,,vtipo)
         ENDIF
      ENDIF
   ENDDO
ENDDO
                       
FUNCTION saca_tipo(archivo,cve,texto_tipo,ren,col)

SET COLOR TO W+/BG+,B+/W
IF archivo="nombres"
   SELECT nombres
   GO TOP
   SEEK cve
   IF FOUND()
      texto=TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s) 
      band_cve = .T.
   ENDIF
ELSE
   SELECT catprin
   GO TOP
   SEEK cve
   IF FOUND()
      texto=nom_obj
      band_cve = .T.
   ENDIF
ENDIF 
IF LASTKEY() <> 27 
   IF band_cve = .T.
      @ren,col SAY texto_tipo+": "+texto
   ELSE
      ponerror("Clave inexistente")
      band_cve = .F.
   ENDIF
ENDIF
RETURN(band_cve)
   

*PROCEDIMIENTO QUE DESPLIEGA LOS RUBROS DE LAS ESPECIFICACIONES
PROCEDURE desprubros(accion,rr1,cr1,rr2,cr2)
*Parmetros: accion    -> Si es Alta o Seleccin de especificaciones 
*            rr1 y rr2 -> Renglones de inicio y termino del marco de rubros
*            cr1 y cr2 -> Columnas de inicio y termino del marco de rubros

PRIVATE cve_sel
re1:=re2:=ce1:=ce2:=0

DO WHILE .T. 
   SELECT catprin
   SET FILTER TO
   IF cve_sel <> NIL
      limpiamenu(rr1-1,cr1-1,rr2+2,cr2+2)
      SET COLOR TO W+/BG+,B+/W
      clave=cve_sel
      RETURN
   ENDIF
   IF accion="C"
      barstatus(8)
   ELSE
      barstatus(1)
   ENDIF
   totrub=0
   COUNT FOR tipo="E" .AND. SUBSTR(cve_obj,5,4)="0000" TO totrub
   IF totrub=0
      ponerror("Catlogo vaco, insertar elemento")
      altaespe("R","0000","Rubro:","A")
      IF abandona=.T.
         SET COLOR TO W+/BG+,B+/W
         RETURN
      ENDIF
   ELSE
      clrub=cat_esp(rr1,cr1,rr2,cr2,"R","E")
      SET COLOR TO W/BG+
      IF LASTKEY()=27
         limpiamenu(rr1-1,cr1-1,rr2+2,cr2+2)
         SET COLOR TO W+/BG+,B+/W
         RETURN
      ELSE
         IF inserta=.T.
            altaespe("R","0000","Rubro:","A")
            inserta=.F.
         ELSE
            IF LASTKEY()=13
               SEEK clrub
               IF disp="S" 
                  re1 = rr1 + 2
                  ce1 = cr1 + 8
                  re2 = rr2 + 2
                  ce2 = cr2 + 8
                  DO CASE
                     CASE accion="A"
                        @17,1 SAY "RUBRO: "+nom_obj
                        despespe(clrub,accion,re1,ce1,re2,ce2)
                     CASE accion="S"
                        despespe(clrub,accion,re1,ce1,re2,ce2)
                     CASE accion="C"
                        despespe(clrub,accion,re1,ce1,re2,ce2)
                  END CASE
               ELSE
                  ponerror("Rubro no disponible")
               ENDIF
            ELSE
               IF LASTKEY()=-9 
                  IF accion="C"
                     altaespe("R","0000","Rubro:",accion,clrub)
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   ENDIF
ENDDO


*FUNCION QUE DESPLIEGA LAS ESPECIFICACIONES
FUNCTION despespe(clafilrub,accion,re1,ce1,re2,ce2)
*Parmetros: clafilrub -> Clave del rubro seleccionado
*            accion    -> Si es Alta o Seleccin de especificaciones 
*            re1 y re2 -> Renglones de inicio y termino del marco de espec.
*            ce1 y ce2 -> Columnas de inicio y termino del marco de espec.

STORE 0 TO rs1,rs2,cs1,cs2
abandona:=.F.
DO WHILE .T. 
   IF accion="C"
      barstatus(8)
   ELSE
      barstatus(1)
   ENDIF
   IF cve_sel <> NIL  
     limpiamenu(re1-1,ce1-1,re2+2,ce2+2)
     limpiamenu(17,1,18,42)
     SET COLOR TO W+/BG+,B+/W
     RETURN(cve_sel)
   ENDIF
   totesp=0
   COUNT FOR SUBSTR(cve_obj,1,4)=SUBSTR(clafilrub,1,4);
   .AND. SUBSTR(cve_obj,5,2)<>"00" .AND. SUBSTR(cve_obj,7,2)="00" TO totesp
   IF totesp=0
       ponerror("Catlogo vaco, insertar elemento")
       altaespe("E",clafilrub,"Especificacin:","A")
       IF abandona=.T.
          limpiamenu(17,1,18,42)
          RETURN
       ENDIF
   ELSE
       clesp=cat_esp(re1,ce1,re2,ce2,"E",clafilrub)
       SET COLOR TO W/BG+
       IF LASTKEY()=27
          limpiamenu(re1-1,ce1-1,re2+2,ce2+2)
          limpiamenu(17,1,18,42)
          SET COLOR TO W+/BG+,B+/W
          RETURN(cve_sel)
       ELSE
          IF inserta=.T.
             altaespe("E",clafilrub,"Especificacin: ","A")
             inserta=.F.
          ELSE   
             IF LASTKEY()=13
                SEEK clesp
                IF disp="S"
                   rs1 = re1 + 2
                   cs1 = ce1 + 8
                   rs2 = re2 + 2
                   cs2 = ce2 + 8
                   DO CASE
                      CASE accion="A"
                        @18,1 SAY "ESPECIFICACION: "+nom_obj
                        despsube(clesp,accion,rs1,cs1,rs2,cs2)
                      CASE accion="S"
                        despsube(clesp,accion,rs1,cs1,rs2,cs2)
                      CASE accion="C"
                        despsube(clesp,accion,rs1,cs1,rs2,cs2)
                   END CASE
                ELSE
                   ponerror("Especificacin no disponible")
                ENDIF
             ELSE
                IF LASTKEY()=-9  
                   IF accion="C"
                      altaespe("E",clafilrub,"Especificacin:",accion,clesp)
                   ENDIF
                ENDIF
             ENDIF
          ENDIF
       ENDIF
   ENDIF
ENDDO

*FUNCION QUE DESPLIEGA LAS SUBESPECIFICACIONES
FUNCTION despsube(clafilesp,accion,rs1,cs1,rs2,cs2)
*Parmetros: clafilesp -> Clave de la especificacin seleccionada
*            accion    -> Si es Alta o Seleccin de especificaciones 
*            rs1 y rs2 -> Renglones de inicio y termino del marco de espec.
*            cs1 y cs2 -> Columnas de inicio y termino del marco de espec.

abandona=.F.
DO WHILE .T. 
   IF accion="C"
      barstatus(9)
   ELSE
      barstatus(6)
   ENDIF
   totsub=0
   COUNT FOR SUBSTR(cve_obj,1,6)=SUBSTR(clafilesp,1,6);
   .AND. SUBSTR(cve_obj,7,2)<>"00" TO totsub
   IF totsub=0
       ponerror("Catlogo vaco, insertar elemento")
       altaespe("S",clafilesp,"Subespecificacin:","A")
       IF abandona=.T.
          RETURN
       ENDIF
   ELSE
       cve_sel=cat_esp(rs1,cs1,rs2,cs2,"S",clafilesp)
       SET COLOR TO W/BG+
       IF LASTKEY()=27
          limpiamenu(rs1-1,cs1-1,rs2+2,cs2+2)
          IF accion="A"
             limpiamenu(18,1,18,42)
          ENDIF
          SET COLOR TO W+/BG+,B+/W
          RETURN
       ELSE
          IF inserta=.T.
             altaespe("S",cve_sel,"Subespecificacin:","A")
             inserta=.F.
          ELSE
             IF LASTKEY()=13
                SEEK cve_sel            
                IF accion="S" 
                   IF disp="S"
                      limpiamenu(rs1-1,cs1-1,rs2+2,cs2+2)
                      limpiamenu(18,1,18,42)
                      SET COLOR TO W+/BG+,B+/W
                      RETURN(cve_sel)
                   ELSE
                      ponerror("Subespecificacin no disponible")
                   ENDIF
                ENDIF
             ELSE
                IF LASTKEY()=-9 
                   IF accion="C"
                      altaespe("S",clafilesp,"Subespecificacin:",accion,cve_sel)
                   ENDIF
                ENDIF
             ENDIF
          ENDIF
       ENDIF
   ENDIF
ENDDO
   
*PROCEDIMIENTOS GENERALES PARA DAR DE ALTA EN EL ARCHIVO CATPRIN LAS 
*ESPECIFICACIONES

*FUNCTION QUE DA DE ALTA UNA ESPECIFICACION
FUNCTION altaespe(catego,cadena,letrero,accion,cve)

crub=SPACE(4)
n_esp=SPACE(40)
dispon=SPACE(1)
existe=.F.

verifica="N"
DO WHILE verifica="N"   
   SET COLOR TO W+/BG,B+/W
   DO CASE
      CASE accion="A"
           IF catego="R"
              @20,5 SAY "Clave: " GET crub PICT "@!" VALID .NOT. crub=" "
              @21,5 SAY letrero     
              @22,5 GET n_esp PICT "@!" VALID .NOT. n_esp=" "
              @23,5 SAY "Disponible: " GET dispon PICT "!" VALID dispon $"SN" 
              READ
              clavegen=crub+"0000"
           ELSE
              IF catego="E"
                 clavegen=busca(1,4,cadena,catego)
              ELSE   
                 clavegen=busca(1,6,cadena,catego)
              ENDIF
              @20,5 SAY "Clave: "+clavegen
              @21,5 SAY letrero
              @22,5 GET n_esp PICT "@!" VALID .NOT. n_esp=" "   
              @23,5 SAY "Disponible: " GET dispon PICT "!" VALID dispon $"SN" 
              READ
           ENDIF
      CASE accion="C"
           SEEK cve
           clavegen=cve
           n_esp=nom_obj
           dispon=disp
           @20,5 SAY "Clave: "+clavegen
           @21,5 SAY letrero
           @22,5 GET n_esp PICT "@!" VALID .NOT. n_esp=" "   
           @23,5 SAY "Disponible: " GET dispon PICT "!" VALID dispon $"SN" 
           READ
   END CASE
   IF LASTKEY()=27 
      ponerror("Operacin cancelada")
      abandona=.T.
      limpiamenu(17,1,18,42)
      limpiamenu(18,40,23,79)
      limpiamenu(20,5,23,42) 
      RETURN(abandona)
   ELSE
      abandona=.F.
      verifica=dialogo("Es correcta? S/N ")
      limpiamenu(18,40,23,79)
      limpiamenu(20,5,23,42)
      SET COLOR TO W+/BG+,B+/W
      IF verifica="S"
         IF accion="A"
            DO CASE
               CASE catego="R"
                    SEEK clavegen
                    IF FOUND() 
                       existe=.T.
                    ELSE
                       GO TOP
                       LOCATE FOR nom_obj=n_esp
                       IF FOUND()
                          existe=.T.
                       ENDIF
                    ENDIF
                    IF existe = .T. 
                       ponerror("Rubro existente")                
                       RETURN
                    ENDIF
               CASE catego="E"
                    GO TOP
                    LOCATE FOR nom_obj=n_esp 
                    IF FOUND() .AND. SUBSTR(cve_obj,1,4)=SUBSTR(clavegen,1,4)
                       ponerror("Especificacin existente") 
                       RETURN
                    ENDIF
               CASE catego="S"
                    GO TOP
                    LOCATE FOR nom_obj=n_esp
                    IF FOUND() .AND. SUBSTR(cve_obj,1,7)=SUBSTR(clavegen,1,7)
                       ponerror("Subespecificacin existente")
                       RETURN
                    ENDIF
              END CASE
         ENDIF
         IF accion="A" 
            APPEND BLANK
         ELSE
            SEEK clavegen
         ENDIF
         REPLACE tipo WITH "E"
         REPLACE cve_obj WITH clavegen
         REPLACE nom_obj WITH n_esp
         REPLACE disp WITH dispon
      ENDIF
   ENDIF
ENDDO

*FUNCION QUE BUSCA LA CLAVE MAS GRANDE TANTO PARA RUBROS,ESPECIFICACIONES Y             
*SUBESPECIFICACIONES
FUNCTION busca(posini,num,cadena,catego)

LOCAL cla3
SET FILTER TO
SET FILTER TO SUBSTR(cve_obj,posini,num)=SUBSTR(cadena,posini,num)
GO BOTTOM
registro=RECNO()
GO registro
clavenc=SUBSTR(cve_obj,5,4)
IF clavenc=" " 
   clavenc="0000"
ENDIF
secuencia=0
rub=SUBSTR(cve_obj,1,4)
esp=SUBSTR(clavenc,1,2)
sub=SUBSTR(clavenc,3,2)
DO CASE
   CASE catego="E"        
        inc=inclave(esp)
        cla3=rub-inc-"00"
   CASE catego="S"
        inc=inclave(sub)
        cla3=rub-esp-inc
ENDCASE
SET FILTER TO
RETURN(cla3)

*FUNCION QUE INCREMENTA EL VALOR DE LAS ESPECIFICACIONES DE ACUERDO
*A LA PORCION DE LA CLAVE PASADA COMO PARAMETRO (RUBRO,ESPECIFICACION O
*SUBESPECIFICACION)
FUNCTION inclave(porcion)

ext=VAL(porcion)
cla1=ext+1
cla2=STRZERO(cla1,2)
RETURN(cla2)


*PROCEDIMIENTO PARA DESPLEGAR CATALOGO DE ESPECIFICACIONES
FUNCTION cat_esp(y1,x1,y2,x2,catego,prefijo)

DECLARE campos[2]
PRIVATE clave

SELECT catprin 
SET FILTER TO
marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG")
DO CASE
   CASE catego="R"
        @y1-1,x2-5 SAY "RUBROS"
        SET FILTER TO tipo="E".AND. SUBSTR(cve_obj,5,4)="0000"
   CASE catego="E"
        @y1-1,x2-15 SAY "ESPECIFICACIONES"
        SET FILTER TO SUBSTR(cve_obj,1,4)=SUBSTR(prefijo,1,4);
        .AND. SUBSTR(cve_obj,5,2)<>"00" .AND. SUBSTR(cve_obj,7,2)="00"
   CASE catego="S"
        @y1-1,x2-18 SAY "SUBESPECIFICACIONES"
        SET FILTER TO SUBSTR(cve_obj,1,6)=SUBSTR(prefijo,1,6);
        .AND. SUBSTR(cve_obj,7,2)<>"00"
ENDCASE
GO TOP
campos[1]="cve_obj"
campos[2]="nom_obj"
DBEDIT(y1,x1,y2,x2,campos,"FUN_ED2",;
{"XXXXXXXXX","XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"},;
{"CLAVE","NOMBRE"},"","  ","","")
SET COLOR TO W+/BG+,B+/W
IF (LASTKEY()=13) .OR. (LASTKEY()=22) .OR. (LASTKEY()=-9)
   clave=&campo_sel
ENDIF
SET FILTER TO
RETURN(clave)

*FUNCION PARA LA EDICION DEL DBEDIT DE LOS CATALOGOS
FUNCTION FUN_ED2
PARAMETERS mode,i
PUBLIC campo_sel

campo_sel:=campos[1]
DO CASE
   CASE mode = 3      && abandona la edicin por archivo vaco
        inserta=.T.
        RETURN(0)
   CASE mode < 4      && continua con la edicin
        RETURN(1)  
   CASE LASTKEY()=27  && abandona la edicin por tecla ESC
        RETURN(0)
   CASE LASTKEY()=22  && activa insercin de elemento por tecla INS y abandona
        inserta=.T.
        RETURN(0)
   CASE LASTKEY()=13  && obtiene la clave y la despliegua en el campo corresp.
        RETURN(0)
   CASE LASTKEY()=-9
        RETURN(0)
ENDCASE

PROCEDURE asigvalor(clave_rel,clsub,acc1,acc2,numreg_ne,vtipo)

SELECT catprin
STORE SPACE(1) TO resp
STORE 0 TO vvalor
STORE SPACE(40) TO observ
resp="N"
DO WHILE resp="N"
   SET ESCAPE ON
   barstatus(5)
   SET COLOR TO W+/BG+,B+/W+
   @10,20 SAY "Valor: " GET vvalor PICT "9999.99" 
   READ
   IF LASTKEY()=27
      ponerror("Operacin cancelada")
      limpiamenu(4,1,21,79)      
      RETURN
   ELSE
      SET FILTER TO
      COUNT FOR tipo="U" TO totuni
      SET FILTER TO tipo="U" 
      arruni=ARRAY(totuni)
      IF totuni=0 
         ponerror("Catlogo vaco, insertar elementos")
         SET FILTER TO
         RETURN
      ELSE
         claunisel=despesp(10,40,16,55,@arruni,totuni)
         LOCATE FOR cve_obj=claunisel
         nomunisel=nom_obj
         limpiamenu(10,40,17,56)
         SET COLOR TO W+/BG+,B+/W  
         @10,40 SAY nomunisel
         SET FILTER TO
         @14,20 SAY "Observacin: " GET observ PICTURE "@S40!"
         READ
         IF LASTKEY()=27
            ponerror("Operacin cancelada")
            limpiamenu(10,20,21,79)
            RETURN
         ELSE
            SET ESCAPE OFF
            resp=dialogo("Es correcto? S/N ")
            IF resp="S"
               SELECT asig_esp
               IF acc1=.T. 
                  APPEND BLANK
               ENDIF
               REPLACE tipo WITH vtipo
               REPLACE cve_per WITH clave_rel
               REPLACE cve_esp WITH clsub
               REPLACE cve_uni WITH claunisel
               REPLACE valor WITH vvalor
               IF observ<>" " 
                  SELECT nota_esp 
                  IF acc2=.T.
                     APPEND BLANK
                  ELSE
                     GO numreg_ne   
                  ENDIF
                  REPLACE tipo WITH vtipo
                  REPLACE cve_per WITH clave_rel
                  REPLACE cve_esp WITH clsub
                  REPLACE nota WITH observ
               ELSE 
                  IF acc2=.F.
                     SELECT nota_esp
                     GO numreg_ne
                     DELETE  
                     PACK
                  ENDIF
               ENDIF
               limpiamenu(10,20,21,79)
               RETURN
            ELSE                                 
               limpiamenu(17,30,21,79)           
            ENDIF
         ENDIF
      ENDIF
   ENDIF
ENDDO

* PROCEDIMIENTO PARA EL DESPLIEGUE DE LOS RUBROS
PROCEDURE list_rubros

PRIVATE cve_sel
SELECT catprin
DO WHILE .T. 
   IF cve_sel <> NIL
      limpiamenu(2,0,18,55)
      SET COLOR TO W+/BG+,B+/W
      clave=cve_sel
      RETURN
   ENDIF
   barstatus(4)
   totrub=0
   COUNT FOR tipo="E" .AND. SUBSTR(cve_obj,5,4)="0000" TO totrub
   IF totrub=0
      ponerror("Catlogo vaco")
      SET COLOR TO W+/BG+,B+/W
      RETURN
   ELSE
      clrub=cat_esp(3,1,16,54,"R","E")
      SET COLOR TO W/BG+
      IF LASTKEY()=27
         limpiamenu(2,0,18,56)
         SET COLOR TO W+/BG+,B+/W
         RETURN
      ELSE
         IF LASTKEY()=13
            list_espe(clrub)
         ENDIF
      ENDIF
   ENDIF
ENDDO

* PROCEDIMIENTO PARA EL DESPLIEGUE DE LAS ESPECIFICACIONES
PROCEDURE list_espe(clafilrub)

DO WHILE .T. 
   IF cve_sel <> NIL  
     limpiamenu(4,10,20,66)
     SET COLOR TO W+/BG+,B+/W
     RETURN(cve_sel)
   ENDIF
   totesp=0
   COUNT FOR SUBSTR(cve_obj,1,4)=SUBSTR(clafilrub,1,4);
   .AND. SUBSTR(cve_obj,5,2)<>"00" .AND. SUBSTR(cve_obj,7,2)="00" TO totesp
   IF totesp=0
       ponerror("Catlogo vaco")
       RETURN
   ELSE
       clesp=cat_esp(5,11,18,64,"E",clafilrub)
       SET COLOR TO W/BG+
       IF LASTKEY()=27
          limpiamenu(4,10,20,66)
          SET COLOR TO W+/BG+,B+/W
          RETURN(cve_sel)
       ELSE
          IF LASTKEY()=13
             list_sub(clesp)
          ENDIF
       ENDIF
   ENDIF
ENDDO

* PROCEDIMIENTO PARA EL DESPLIEGUE DE LAS SUBESPECIFICACIONES
PROCEDURE list_sub(clafilesp)

DO WHILE .T. 
   totsub=0
   COUNT FOR SUBSTR(cve_obj,1,6)=SUBSTR(clafilesp,1,6);
   .AND. SUBSTR(cve_obj,7,2)<>"00" TO totsub
   IF totsub=0
       ponerror("Catlogo vaco")
       RETURN
   ELSE
       cve_sel=cat_esp(7,21,20,74,"S",clafilesp)
       SET COLOR TO W/BG+
       IF LASTKEY()=27
          limpiamenu(6,20,22,76)
          SET COLOR TO W+/BG+,B+/W
          RETURN
       ENDIF
   ENDIF
ENDDO

*FUNCION QUE DESPLIEGA LAS UNIDADES DE MEDIDA PARA SU SELECCION
FUNCTION despesp
PARAMETERS y1,x1,y2,x2,arreglo,nrec

GO TOP
FOR i=1 TO nrec
    arreglo[i]=nom_obj
    SKIP
NEXT
DO WHILE .T.
   marcmenu(y1,x1,y2,x2,"B/W+,W+/B+")
   ASORT(arreglo)
   reg=ACHOICE(y1+1,x1+1,y2-1,x2-1,arreglo,"","valida")
   sel=arreglo[reg]
   LOCATE FOR nom_obj=sel 
   clavsel=cve_obj
   SET COLOR TO W+/BG+,B+/W
   RETURN(clavsel)
ENDDO   


*PROCEDIMIENTO PARA REALIZAR CAMBIOS EN LOS VALORES DE LAS ESPECIFICACIONES
*ASIGNADAS A CANDIDATOS, PUESTOS, TEST Y CURSOS

PROCEDURE CAMB_ESPE(base,vtipo,texto_tipo)
PUBLIC cont
PUBLIC cve_per
PRIVATE band_cve

DO WHILE .T.
    barstatus(7)
    SET ESCAPE ON
    band_cve = .F.
    DO WHILE band_cve = .F.
      SET COLOR TO W/BG+,B+/W
      IF base="catprin"
         SETKEY(-1,{||cat_gral(6,3,20,56,"catprin",@vtipo)})
      ELSE
         SETKEY(-1,{||cat_gral(6,3,20,56,"nombres",@vtipo)})      
      ENDIF
      clave:=cve_rel:=SPACE(8)
      @2,5 SAY "Clave: " GET clave PICT "@!" VALID .NOT. clave=" "
      READ
      IF LASTKEY()=27
         RETURN
      ELSE
         cve_rel=clave
         band_cve=saca_tipo(base,cve_rel,texto_tipo,2,25)
      ENDIF
   ENDDO
   band = .F.
   DO WHILE band = .F.
      SELECT asig_esp
      SET COLOR TO W+/BG+,B+/W
      @4,10 SAY "Rubro"
      @6,10 SAY "Especificacin"
      @8,10 SAY "Subespecificacin"
      COUNT FOR cve_per=cve_rel TO totreg
      IF totreg=0
         ponerror("No existen especificaciones asignadas")   
         SET COLOR TO W+/BG+,B+/W
         CLOSE ALL
         RETURN
      ELSE
         cont=1
         GO TOP
         DO WHILE !EOF() 
            barstatus(2)
            crub:=cesp:=csub:=cuni:=SPACE(9)
            accion=.F.
            vvalor:=0
            SELECT asig_esp
            recae=RECNO()
            SET COLOR TO W+/BG+,B+/W
            IF cve_per=cve_rel
               csub=cve_esp
               recne=LOCAL_ESP(csub,.F.)
               INKEY(0)
               DO CASE
                  CASE LASTKEY()=5            //FLECHA ARRIBA
                       IF cont=1
                          GO BOTTOM
                          cont=totreg
                       ELSE
                          GO recae
                          SKIP -1
                          cont:=cont-1
                       ENDIF
                  CASE LASTKEY()=24            //FLECHA ABAJO
                       IF cont=totreg
                          GO TOP
                          cont=1
                       ELSE
                          GO recae
                          SKIP 
                          cont:=cont+1
                       ENDIF
                  CASE LASTKEY()=27           //ESCAPE
                       SET COLOR TO W+/BG+,B+/W
                       limpiamenu(2,1,21,79)
                       band = .T.
                       EXIT
                  CASE LASTKEY()=13           //RETURN
                       GO recae
                       pantcamesp=SAVESCREEN(0,0,79,24)
                       asigvalor(cve_rel,csub,.F.,accion,recne,vtipo)
                       SET COLOR TO W+/BG+,B+/W
                       RESTSCREEN(0,0,79,24,pantcamesp)
                       GO recae
               ENDCASE
            ELSE
               IF LASTKEY()=5
                  SKIP-1
               ELSE
                  SKIP
               ENDIF
            ENDIF
         ENDDO
      ENDIF
   ENDDO
ENDDO


PROCEDURE BAJA_ESPE(base,vtipo,texto_tipo)

PUBLIC cont
PUBLIC cve_per
PRIVATE band_cve

DO WHILE .T.
    barstatus(7)
    SET ESCAPE ON
    band_cve = .F.
    DO WHILE band_cve = .F.
      SET COLOR TO W/BG+,B+/W
      IF base="catprin"
         SETKEY(-1,{||cat_gral(6,3,20,56,"catprin",@vtipo)})
      ELSE
         SETKEY(-1,{||cat_gral(6,3,20,56,"nombres",@vtipo)})      
      ENDIF
      clave:=cve_rel:=SPACE(8)
      @2,5 SAY "Clave: " GET clave PICT "@!" VALID .NOT. clave=" "
      READ
      IF LASTKEY()=27
         RETURN
      ELSE
         cve_rel=clave
         band_cve=saca_tipo(base,cve_rel,texto_tipo,2,25)
      ENDIF
   ENDDO
   band = .F.
   DO WHILE band = .F.
      SELECT asig_esp
      @4,10 SAY "Rubro"
      @6,10 SAY "Especificacin"
      @8,10 SAY "Subespecificacin"
      COUNT FOR cve_per=cve_rel TO totreg
      IF totreg=0
         ponerror("No existen especificaciones asignadas")   
         SET COLOR TO W+/BG+,B+/W
         CLOSE ALL
         RETURN
      ELSE
         cont=1
         GO TOP
         DO WHILE !EOF()
            barstatus(2)
            crub:=cesp:=csub:=cuni:=SPACE(9)
            accion=.F.
            vvalor:=0
            SELECT asig_esp
            recae=RECNO()
            SET COLOR TO W+/BG+,B+/W
            IF cve_per=cve_rel
               csub=cve_esp
               statusreg=DELETED()
               recne=LOCAL_ESP(csub,statusreg)
               INKEY(0)
               DO CASE
                  CASE LASTKEY()=5            //FLECHA ARRIBA
                       IF cont=1
                          GO BOTTOM
                          cont=totreg
                       ELSE
                          GO recae
                          SKIP -1
                          cont:=cont-1
                       ENDIF
                  CASE LASTKEY()=24            //FLECHA ABAJO
                       IF cont=totreg
                          GO TOP
                          cont=1
                       ELSE
                          GO recae
                          SKIP 
                          cont:=cont+1
                       ENDIF
                  CASE LASTKEY()=27           //ESCAPE
                       SELECT asig_esp
                       PACK
                       SELECT nota_esp
                       PACK
                       limpiamenu(2,1,21,79)
                       band = .T.
                       EXIT
                  CASE LASTKEY()=13           //RETURN
                       IF statusreg=.T.
                          ponerror("Registro marcado para borrado")   
                          SET COLOR TO W+/BG+,B+/W
                          resp=dialogo("Desea desmarcarlo? S/N")
                          IF resp="S"
                             GO recae
                             RECALL
                             SELECT nota_esp
                             SEEK cve_per+csub
                             IF FOUND()
                                RECALL
                             ENDIF
                          ENDIF
                       ELSE
                          resp=dialogo("Esta seguro de borrar? S/N")
                          IF resp="S"
                             GO recae
                             DELETE
                             SELECT nota_esp
                             GO recne
                             DELETE
                          ENDIF
                       ENDIF
                       SELECT asig_esp
                       GO recae
                       limpiamenu(14,40,21,79)
               ENDCASE
            ELSE
               IF LASTKEY()=5
                  SKIP-1
               ELSE
                  SKIP
               ENDIF
            ENDIF
         ENDDO
      ENDIF
   ENDDO
ENDDO


PROCEDURE CONS_ESPE(base,vtipo,texto_tipo)
PUBLIC cont
PUBLIC cve_per
PRIVATE band_cve

DO WHILE .T.
    barstatus(7)
    SET ESCAPE ON
    band_cve = .F.
    DO WHILE band_cve = .F.
      SET COLOR TO W/BG+,B+/W
      IF base="catprin"
         SETKEY(-1,{||cat_gral(6,3,20,56,"catprin",@vtipo)})
      ELSE
         SETKEY(-1,{||cat_gral(6,3,20,56,"nombres",@vtipo)})      
      ENDIF
      clave:=cve_rel:=SPACE(8)
      @2,5 SAY "Clave: " GET clave PICT "@!" VALID .NOT. clave=" "
      READ
      IF LASTKEY()=27
         RETURN
      ELSE
         cve_rel=clave
         band_cve=saca_tipo(base,cve_rel,texto_tipo,2,25)
      ENDIF
   ENDDO
   band = .F.
   DO WHILE band = .F.
      SELECT asig_esp
      @4,10 SAY "Rubro"
      @6,10 SAY "Especificacin"
      @8,10 SAY "Subespecificacin"
      COUNT FOR cve_per=cve_rel TO totreg
      IF totreg=0
         ponerror("No existen especificaciones asignadas")   
         SET COLOR TO W+/BG+,B+/W
         CLOSE ALL
         RETURN
      ELSE
         cont=1
         GO TOP
         DO WHILE !EOF()
            barstatus(3)
            crub:=cesp:=csub:=cuni:=SPACE(9)
            accion=.F.
            vvalor:=0
            SELECT asig_esp
            recae=RECNO()
            SET COLOR TO W+/BG+,B+/W
            IF cve_per=cve_rel
               csub=cve_esp
               recne=LOCAL_ESP(csub,.F.)
               INKEY(0)
               DO CASE
                  CASE LASTKEY()=5            //FLECHA ARRIBA
                       IF cont=1
                          GO BOTTOM
                          cont=totreg
                       ELSE
                          GO recae
                          SKIP -1
                          cont:=cont-1
                       ENDIF
                  CASE LASTKEY()=24            //FLECHA ABAJO
                       IF cont=totreg
                          GO TOP
                          cont=1
                       ELSE
                          GO recae
                          SKIP 
                          cont:=cont+1
                       ENDIF
                  CASE LASTKEY()=27           //ESCAPE
                       limpiamenu(2,1,21,79)
                       band = .T.
                       EXIT
               ENDCASE
            ELSE
               IF LASTKEY()=5
                  SKIP-1
               ELSE       
                  SKIP
               ENDIF
            ENDIF
         ENDDO
      ENDIF
   ENDDO
ENDDO

*FUNCION QUE LOCALIZA LOS NOMBRES DE RUBROS, SUBESPECIFICACIONES Y ESPECIFICACIONES
*ASIGNADOS A PUESTOS, TEST, CANDIDATOS, Y CURSOS TANTO EN EL PROCESO DE BAJAS
*COMO EN EL DE CAMBIOS
    
FUNCTION LOCAL_ESP(csub,statusreg)

PRIVATE nrub,nesp,nsub

@21,5 SAY REPLICATE(" ",15)
IF statusreg=.T.
   @21,5 SAY LTRIM(STR(cont))+" (DEL)"+" de "+LTRIM(STR(totreg))
ELSE
   @21,5 SAY LTRIM(STR(cont))+" de "+LTRIM(STR(totreg))
ENDIF
cuni=cve_uni
vvalor=valor
crub=SUBSTR(cve_esp,1,4)+"0000"
cesp=SUBSTR(cve_esp,1,6)+"00"
SELECT catprin
SEEK crub
nrub=nom_obj
SEEK cesp
nesp=nom_obj
SEEK csub
nsub=nom_obj
SEEK cuni
nuni=nom_obj
SELECT nota_esp
SEEK cve_rel+csub
regnota=RECNO()
accion=.F.
obse=nota
IF obse=" "
   accion=.T.
ENDIF
SELECT asig_esp
@4,40 SAY nrub
@6,40 SAY nesp
@8,40 SAY nsub
@10,20 SAY "Valor:" 
@10,28 SAY vvalor
@10,40 SAY nuni
@14,20 SAY "Observacin:  " + obse
RETURN(regnota)


*******************************************************
FUNCTION saca_tipo2(archivo,cve,texto_tipo,prefijo,ren,col,recorta)

SET COLOR TO W+/BG+,B+/W
SELECT &archivo
IF archivo = "catprin"
  GO TOP
  LOCATE FOR (cve_obj = cve) .AND. (tipo = prefijo)
  IF FOUND()
     texto=nom_obj
     band_cve = .T.
  ELSE
    band_cve = .F.
  ENDIF 
  IF LASTKEY() <> 27 
     IF band_cve = .T.
        IF recorta = .T. 
          @ren,col SAY texto_tipo+": "+SUBSTR(texto,1,15)
        ELSE
          @ren,col SAY texto_tipo+": "+texto
        ENDIF 
     ELSE
        ponerror("Clave inexistente")
        band_cve = .F.
     ENDIF 
  ENDIF 
ELSE
  IF archivo = "cat_tabu"
    GO TOP
    LOCATE FOR clave_tab = cve 
    IF FOUND()
       texto=monto_tab
       band_cve = .T.
    ENDIF    
    IF LASTKEY() <> 27 
       IF band_cve = .T.
          @ren,col SAY texto_tipo + ": " + texto
       ELSE
          ponerror("Clave inexistente")
          band_cve = .F.
       ENDIF  
    ENDIF  
  ELSE
    IF archivo = "nombres"
      GO TOP
      LOCATE FOR (cve_per = cve) .AND. (tipo = prefijo)
      IF FOUND()
         texto=TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s)  
         band_cve = .T.
      ELSE
        band_cve = .F.
      ENDIF    
      IF LASTKEY() <> 27 
         IF band_cve = .T.
           @ren, col SAY texto
         ELSE
            ponerror("Clave inexistente")
            band_cve = .F.
         ENDIF  
      ENDIF  
    ENDIF
  ENDIF
ENDIF 
RETURN(band_cve)

