****PROCEDIMIENTO QUE REALIZA EL ALTA DE 
***PERIODOS VACACIONALES

PROCEDURE ALTAPERVAC

USE C_PER_VA
continua = "S"
MARCMENU(5,15,15,65,"W+/BG")  
DO WHILE continua = "S"
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @6,16 CLEAR TO 14,64
  DO borramen
  vdesde:=vhasta:=vnum_d_vac:=0
  @6,16 CLEAR TO 14,64
  @7,29 SAY "Perodos Vacacionales"
  @9,32 SAY "Desde: " GET vdesde PICTU "99" VALID .NOT. vdesde = 0
  @9,43 SAY "ao(s)"
  @10,32 SAY "Hasta: " GET vhasta PICTU "99" VALID .NOT. vhasta = 0
  @10,43 SAY "ao(s)"
  @11,25 SAY "Das Anuales correspondientes: " GET vnum_d_vac PICTU "99" VALID .NOT. vnum_d_vac = 0
  READ
  IF LASTKEY() = 27
    RETURN
  ELSE
    IF vdesde > vhasta
      ponerror("Perodo Inicial Mayor que Final")
    ELSE
      GO TOP
      LOCATE FOR (desde = vdesde) .OR. (hasta = vhasta) .OR. (desde = vdesde .AND. hasta = vhasta .AND. disp = "S")
      IF FOUND()
        ponerror("Perodo Vacacional Existente")
      ELSE
        APPEND BLANK
        REPLACE desde WITH vdesde
        REPLACE hasta WITH vhasta
        REPLACE num_d_vac WITH vnum_d_vac
      ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otra alta (S/N)?") 
ENDDO
CLOSE ALL
RETURN


*****PROCEDIMIENTO QUE REALIZA CAMBIOS EN EL CATALOGO DE
***PERIODOS VACACIONALES
PROCEDURE CAMBPERVAC

continua="S"
color="W+/BG+,B+/W"
SETCOLOR(color)
@3,1 CLEAR TO 23,79
USE C_PER_VA
DO WHILE continua="S"
  clave = SPACE(2)
  CAMPOS := {"DESDE","HASTA","NUM_D_VAC"}
  TITUL := {"DESDE","HASTA","DIAS ANUALES CORRESPONDIENTES"}
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @21,1 CLEAR TO 22,79
  DO borramen
  @4,29 SAY "PERIODOS VACACIONALES"
  MARCMENU(5,4,15,72,color)
  DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
  SET COLOR TO W+/BG+,B+/W
  IF (LASTKEY()=-9)
    clave=&campo_sel
    GO TOP
    LOCATE FOR desde = clave
    vdesde:=ini:=clave
    vhasta:=fin:=hasta
    vnum_d_vac:=dias:=num_d_vac
    vdisp = disp
    bandcont = .F.
    DO WHILE bandcont = .F.
      vdesde = ini
      vhasta = fin
      vnum_d_vac = dias
      @18,10 SAY "Desde:" GET vdesde PICTU "99" VALID .NOT. vdesde = 0
      @18,20 SAY "ao(s)"
      @19,10 SAY "Hasta:" GET vhasta PICTU "99" VALID .NOT. vhasta = 0
      @19,20 SAY "ao(s)"
      @21,10 SAY "Das Anuales correspondientes: " GET vnum_d_vac PICTU "99" VALID .NOT. vnum_d_vac = 0
      @22,20 SAY "Disponible: " GET vdisp PICTU "@!" VALID .NOT. vdisp = " "
      READ
      IF LASTKEY()=27
        ponerror("Operacion Cancelada")
        bandcont = .T.
      ELSE
        IF vdesde > vhasta
          ponerror("Perodo Inicial Mayor que Final")
          bandcont = .F.
         ELSE
           LOCATE FOR desde = clave
           REPLACE desde WITH vdesde
           REPLACE hasta WITH vhasta
           REPLACE num_d_vac WITH vnum_d_vac
           REPLACE disp WITH vdisp
           bandcont = .T.
         ENDIF
      ENDIF
    ENDDO
  ENDIF
  continua = dialogo("Realizar otro cambio? S/N")
ENDDO
CLOSE ALL
RETURN 

******************************************
*PROCEDIMIENTO QUE DESPLIEGA EL CATALOGO DE PERIODOS VACACIONALES
PROCEDURE DESPERVAC

DECLARE CAMP[3]
DECLARE TITUL[3]
SELECT 1
USE C_PER_VA
CAMPOS := {"DESDE","HASTA","NUM_D_VAC"}
TITUL := {"DESDE","HASTA","DIAS ANUALES CORRESPONDIENTES"}
color="W+/BG+,B+/W"
SETCOLOR(color)
@6,16 CLEAR TO 14,64
DO borramen
@4,29 SAY "PERIODOS VACACIONALES"
MARCMENU(5,4,15,72,color)
DBEDIT(6,5,14,70,CAMPOS,"funci",.F.,TITUL)
CLOSE ALL
RETURN

*************************************************************
*PROCEDIMIENTO QUE REALIZA CAMBIOS EN LA PLANTILLA DEL TRABAJADOR
PROCEDURE CAMBPLANTI

SELECT 1
USE nombres
SELECT 2
USE catprin
SELECT 3
USE plantill
continua = "S"
DO WHILE continua = "S"
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,19,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    band_cve = saca_tipo2("nombres",clave,"Trabajador","W",8,15,.T.)
    IF band_cve = .T.
        SELECT 3
        LOCATE FOR cve_per = clave
        vcve_puest:=puesto:=cve_puest
        vcve_area:=area:=cve_area
        vsueldo = sueldo
        vhorario = horario
        vnum_af_ss = num_af_ss
        vtipo_cont:=contrato:=tipo_cont
        bandpues = .F.
        DO WHILE bandpues = .F.
          vcve_puest = puesto
          @10,14 SAY  "Puesto: "
          SETKEY(-2,{||CAT_GRAL_I(11,2,19,62,"catprin","P","vcve_puest")})
          @10,22 GET vcve_puest PICTU "@!" VALID .NOT. vcve_puest = " " 
          READ
          IF LASTKEY() = 27
            ponerror("Operacin Cancelada")
            bandpues = .T.
          ELSE
            band_cve = saca_tipo2("catprin",vcve_puest,"Puesto","P",10,31,.T.)
            IF band_cve = .T.
               bandcont = .T.
               bandarea = .F.
              DO WHILE bandarea = .F.
               vcve_area = area
               @12,14 SAY  "Area: "
               SETKEY(-3,{||CAT_GRAL_I(11,2,19,62,"catprin","A","vcve_area")})
               @12,22 GET vcve_area PICTU "@!" VALID .NOT. vcve_area = " " 
               READ
               IF LASTKEY()=27
                 ponerror("Operacin Cancelada")
                 bandarea = .T.
                 bandpues = .T.
               ELSE
                 band_cve = saca_tipo2("catprin",vcve_area,"Area","A",12,31,.T.)
                 IF band_cve = .T.
                   bandarea = .T.
                   @14,21 SAY "Sueldo: " GET vsueldo PICTU "99999.99" VALID .NOT. vsueldo = 0
                   @14,39 SAY "Horario: " GET vhorario PICTU "@!" VALID .NOT. vhorario = " "
                   @16,23 SAY "Num. Afil. Seguro Social: " GET vnum_af_ss 
                   READ
                   IF LASTKEY () = 27
                     ponerror("Operacin Cancelada")
                     bandarea = .T.
                     bandpues = .T.
                   ELSE
                     bandtipocont = .F.
                     DO WHILE bandtipocont = .F.
                       bandarea = .T.
                       bandpues = .T.
                       bandtipocont = .T.
                       vtipo_cont = contrato
                       @18,14 SAY "Tipo de Contratacin: " GET vtipo_cont PICTU "@!" VALID .NOT. vtipo_cont = " "
                       SETKEY(-4,{||CAT_GRAL_I(11,2,19,62,"catprin","Q","vtipo_cont")})
                       @18,38 GET vtipo_cont PICTU "@!" VALID .NOT. vtipo_cont = " " 
                       READ
                       IF LASTKEY()=27
                         ponerror("Operacin Cancelada")
                         bandarea = .T.
                         bandpues = .T.
                         bandtipocont = .T.
                       ELSE
                         band_cve = saca_tipo2("catprin",vtipo_cont," ","Q",18,47,.T.)
                         IF band_cve = .T.
                           SELECT 3
                           LOCATE FOR cve_per = clave
                           REPLACE cve_puest WITH vcve_puest
                           REPLACE cve_area WITH vcve_area
                           REPLACE horario WITH vhorario
                           REPLACE num_af_ss WITH vnum_af_ss
                           REPLACE tipo_cont WITH vtipo_cont
                           bandarea = .T.
                           bandpues = .T.
                           bandtipocont = .T.
                         ELSE
                           bandtipocont = .F.
                         ENDIF
                       ENDIF
                     ENDDO
                   ENDIF
                 ELSE
                   bandarera = .F.
                 ENDIF
               ENDIF
              ENDDO /*bandarea*/
            ELSE
              bandpues = .F.
            ENDIF
          ENDIF
        ENDDO /*bandpues*/
    ENDIF
  ENDIF
  continua=dialogo("Realizar otro Cambio (S/N)?") 
ENDDO
CLOSE ALL
RETURN


*************************************************************
*PROCEDIMIENTO QUE REALIZA CAMBIOS EN DATOS PERSONALES DEL TRABAJADOR
PROCEDURE CAMBDATPER

SELECT 1
USE nombres
SELECT 2
USE datos_pe
SELECT 3
USE direc
continua ="S"
DO WHILE continua = "S"
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(8,15,15,65,"W+/BG")
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @9,25 SAY "Introduzca la clave del Trabajador:"   
  @11,35 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    *band_cve = saca_tipo2("nombres",clave,"Trabajador","W",8,15,.T.)
    *IF band_cve = .T.
        SELECT 1
        GO TOP 
        LOCATE FOR cve_per = clave .AND. tipo = "W"
        vpaterno = paterno
        vmaterno = materno
        vnombre_s = nombre_s
        vtipo = "W"
        SELECT 2
        LOCATE FOR cve_per = clave
        vestado_civ:=vedo_civ1:=estado_civ      
        vsexo:=vsexo1:=sexo
        vestatura = estatura
        vpeso = peso
        vfech_nac = DTOC(fech_nac)
        vnacionalid = nacionalid
        vrfc_trab = rfc_trab
        vfech_ingr = DTOC(fech_ingr)
        SELECT 3
        GO TOP
        LOCATE FOR cve_per = clave .AND. tipo = "W"
        vcalle = calle
        vnum_ext = num_ext
        vnum_int = num_int
        vcolonia = colonia
        vcp = cp
        vciudad = ciudad
        vestado = estado
        vtel = tel
        vext = ext
        @1,0 CLEAR TO 21,78
        marcmenu(4,1,20,77,"W+/BG")
        @5,3 SAY "Nombre(s):" GET vnombre_s PICTURE "@S12!" VALID .NOT. vnombre_s=" " 
        @5,28 SAY "A.Paterno:" GET vpaterno PICTURE "@S12!" VALID .NOT. vpaterno=" "
        @5,52 SAY "A.Materno:" GET vmaterno PICTURE "@S12!" VALID .NOT. vmaterno=" "
        @7,2 SAY "-- DIRECCION " + REPLICATE("-",61)
        @8,3 SAY "Calle:" GET vcalle PICTURE "@S25!" VALID .NOT. vcalle=" "
        @8,39 SAY "Num. Ext.:" GET vnum_ext PICTURE "9999"
        @8,57 SAY "Num. Int.:" GET vnum_int PICTURE "999"
        @10,3 SAY "Colonia:" GET vcolonia PICTURE "@S15!"
        @10,29 SAY "Ciudad:" GET vciudad PICTURE "@S10!" VALID .NOT. vciudad=" " 
        @10,54 SAY "Estado:" GET vestado PICTURE "@S12!"
        @12,3 SAY "C.P.:" GET vcp PICTURE "99999"
        @12,15 SAY "Telfono:" GET vtel PICTURE "9-99-99-99"
        @12,41 SAY "Extensin:" GET vext PICTURE "9999"
        @14,2 SAY "-- DATOS GENERALES "+ REPLICATE("-",55)
        @15,3 SAY "Estado Civil:" GET vedo_civ1 VALID val_gets(2,14,16,19,29)
        @15,40 SAY "Sexo:" GET vsexo1 VALID val_gets(1,14,45,18,55)
        @17,3 SAY "Estatura:" GET vestatura PICTURE "9.99"
        @17,20 SAY "Peso:" GET vpeso PICTURE "999"
        @17,40 SAY "Fecha de Nacimiento:" GET vfech_nac PICTURE "99/99/99" 
        @19,3 SAY "Nacionalidad:" GET vnacionalid PICTURE "@!"
        @19,40 SAY "Reg. Fed. Caus.:" GET vrfc_trab PICTURE "!!!!######-XXX"
        READ
        IF LASTKEY() <> 27
          IF vedo_civ1="SEPARADO"
             vestado_civ="E"
          ELSE
             vestado_civ=SUBSTR(vedo_civ1,1,1)
          ENDIF
          vsexo = vsexo1
          vcve_per = clave
          vfech_ingr = CTOD(vfech_ingr)
          vfech_nac = CTOD(vfech_nac)
          vtipo = "W"
          SELECT 1
          LOCATE FOR cve_per = clave .AND. tipo = "W"
          REPLACE paterno WITH vpaterno
          REPLACE materno WITH vmaterno
          REPLACE nombre_s WITH vnombre_s
          SELECT 2
          LOCATE FOR cve_per = clave .AND. tipo = "W"
          a=FCOUNT()
          FOR i= 1 TO a
            nomcpo=FIELD(i)
            nomvar="V"+FIELD(nomcpo)
            REPLACE &nomcpo WITH &nomvar
          NEXT
          SELECT 3
          LOCATE FOR cve_per = clave .AND. tipo = "W"
          a=FCOUNT()
          FOR i= 1 TO a
            nomcpo=FIELD(i)
            nomvar="V"+nomcpo
            REPLACE &nomcpo WITH &nomvar
          NEXT
        ELSE
          ponerror("Operacin Cancelada")
        ENDIF
    *ENDIF
  ENDIF
  continua=dialogo("Realizar otro Cambio (S/N)?") 
ENDDO
CLOSE ALL
RETURN

******************************************
*PROCEDIMIENTO QUE DESPLIEGA LOS DATOS DEL TRABAJADOR
PROCEDURE DESPTRAB

SELECT 1
USE catprin
SELECT 2
USE nombres
SELECT 3
USE datos_pe
SELECT 4
USE plantill
SELECT 5
USE direc
continua = "S"
DO WHILE continua = "S"
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(8,15,15,65,"W+/BG")
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @9,25 SAY "Introduzca la clave del Trabajador:"   
  @11,35 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    *band_cve = saca_tipo2("nombres",clave,"Trabajador","W",5,22,.T.)
    *IF band_cve = .T.
        SELECT 2
        GO TOP 
        @1,0 CLEAR TO 21,78
        marcmenu(2,1,22,77,"W+/BG")
        color="W+/BG+,B+/W"
        SETCOLOR(color)
        LOCATE FOR cve_per = clave .AND. tipo = "W"
        vpaterno = paterno
        vmaterno = materno
        vnombre_s = nombre_s
        @3,3 SAY "Nombre(s): "+vnombre_s 
        @3,28 SAY "A.Paterno: "+vpaterno 
        @3,52 SAY "A.Materno: "+vmaterno 
        SELECT 5
        LOCATE FOR cve_per = clave .AND. tipo = "W"
        vcalle = calle
        vnum_ext = num_ext
        vnum_int = num_int
        vcolonia = colonia
        vcp = cp
        vciudad = ciudad
        vestado = estado
        vtel = tel
        vext = ext
        @5,2 SAY "-- DIRECCION " + REPLICATE("-",61)
        @6,3 SAY "Calle: "+vcalle
        @6,39 SAY "Num. Ext.: "+STR(vnum_ext)
        @6,57 SAY "Num. Int.: "+STR(vnum_int)
        @8,3 SAY "Colonia: "+vcolonia
        @8,29 SAY "Ciudad: "+vciudad
        @8,54 SAY "Estado: "+vestado
        @10,3 SAY "C.P.: "+STR(vcp)
        @10,15 SAY "Telfono: "+vtel 
        @10,41 SAY "Extensin: "+STR(vext)
        SELECT 3
        LOCATE FOR cve_per = clave
        vestado_civ:=vedo_civ1:=estado_civ
        vsexo:=vsexo1:=sexo
        vestatura = estatura
        vpeso = peso
        vfech_nac = DTOC(fech_nac)
        vnacionalid = nacionalid
        vrfc_trab = rfc_trab
        vfech_ingr = DTOC(fech_ingr)
        @12,2 SAY "-- DATOS GENERALES "+ REPLICATE("-",55)
        @13,3 SAY "Estado Civil: "+vedo_civ1
        @13,40 SAY "Sexo: "+vsexo1
        @15,3 SAY "Estatura: "+STR(vestatura)
        @15,20 SAY "Peso: "+STR(vpeso)
        @15,40 SAY "Fecha de Nacimiento: "+vfech_nac
        @17,3 SAY "Nacionalidad: "+vnacionalid
        @17,40 SAY "Reg. Fed. Caus.: "+vrfc_trab 
        SELECT 4
        LOCATE FOR cve_per = clave
        vcve_puest:=puesto:=cve_puest
        vcve_area:=area:=cve_area
        vsueldo = sueldo
        vhorario = horario
        vnum_af_ss = num_af_ss
        vtipo_cont:=contrato:=tipo_cont
        @18,2 SAY "-- DATOS GENERALES "+ REPLICATE("-",55)
        @19,3 SAY "Puesto: "+cve_puest
        puesto = cve_puest
        @19,36 SAY "Area: "+cve_area
        area = cve_area
        @20,21 SAY "Sueldo: "
        @20,29 SAY sueldo
        @20,39 SAY "Horario: "
        @20,48 SAY horario
        @21,3 SAY "Num. Afil. S.S.: "
        @21,20 SAY num_af_ss
        @21,42 SAY "Contrato: "
        @21,53 SAY tipo_cont
        contrato = tipo_cont
        SELECT 1
        GO TOP 
        LOCATE FOR cve_obj = puesto .AND. tipo = "P"
        @19,20 SAY SUBSTR(nom_obj,1,15)
        GO TOP 
        LOCATE FOR cve_obj = area .AND. tipo = "A"
        @19,51 SAY SUBSTR(nom_obj,1,15)
        GO TOP
        LOCATE FOR cve_obj = contrato .AND. tipo = "Q"
        @21,61 SAY SUBSTR(nom_obj,1,15)
        ponerror("Presione cualquier tecla")
    *ENDIF
  ENDIF
  color = "N/BG"
  SETCOLOR(color)
  @23,3 SAY REPLICATE(CHR(219),76)
  continua=dialogo("Realizar otro Despliegue (S/N)?") 
ENDDO
CLOSE ALL
RETURN


*************************************************************
*PROCEDIMIENTO QUE DA DE ALTA VACACIONES DEL TRABAJADOR
PROCEDURE ALTAVAC             

SELECT 1
USE nombres
SELECT 2
USE datos_pe
SELECT 3
USE c_per_va
SELECT 4
USE vacactra
SELECT 5
USE plantill
continua ="S"
DO WHILE continua = "S"
  clave:=vfec_ini_va:=vfec_fin_va:=SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,6,18,74,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    SELECT 1
    band_cve = saca_tipo2("nombres",clave,"Trabajador","W",8,15,.T.)
    IF band_cve = .T.
      *NUMERO DE VACACIONES A LAS QUE TIENE DERECHO
      SELECT 2
      LOCATE FOR cve_per = clave .AND. tipo = "W"
      vfech_ingr = DTOC(fech_ingr)
      antigu = antig(vfech_ingr)
      @9,10 SAY "Antigedad del trabajador: "
      @9,37 SAY antigu
      anios = VAL(SUBSTR(antigu,1,2))
      IF anios > 0
        SELECT 3
        GO TOP
        ***EVALUA DIAS EJERCIDOS Y DISPONIBLES DE ACUERDO A ANTIGUEDAD****
        LOCATE FOR desde >= anios
        vnum_d_vac = num_d_vac
        @10,10 SAY "Numero de das correspondientes : "
        @10,43 SAY vnum_d_vac
        SELECT 4
        SUM(n_dias_eje) TO vn_dias_eje FOR cve_per = clave
        totdias = diasejer(anios)
        diasdisp = totdias - vn_dias_eje
        @11,10 SAY "Das disponibles: "
        @11,28 SAY diasdisp
        IF diasdisp > 0
          @12,10 SAY "Peticin Nmero Vacaciones: " GET vn_dias_eje PICTU "99" VALID .NOT. vn_dias_eje = 0
          @13,10 SAY "Fecha Inicial: " GET vfec_ini_va PICTU "99/99/99" VALID .NOT. vfec_ini_va = " " 
          @14,10 SAY "Fecha Final: " GET vfec_fin_va PICTU "99/99/99" VALID .NOT. vfec_fin_va = " " 
          READ
          IF LASTKEY() <> 27
            ****EVALUA SI EXISTEN TRABAJADORES CON MISMO PUESTO CON VACACIONES***
            SELECT 5
            LOCATE FOR cve_per = clave 
            vcve_puest = cve_puest
            vcve_area = cve_area
            GO TOP
            COUNT FOR cve_puest = vcve_puest .AND. cve_area = vcve_area TO totregs
            IF totregs > 0
              ***PENDIENTE LA EVALUACION DE TRABAJADORES CON MISMO PUESTO Y AREA
              *regtrab = ARRAY(totregs)
              *i = 1
              *LOCATE FOR cve_puest = vcve_puest .AND. cve_area = vcve_area 
              *DO WHILE FOUND()
              *  regtrab[i] = cve_per
              *  i = i + 1
              *ENDDO
              *SELECT 4
              *FOR i = 1 TO totregs
              *  GO TOP
              *  LOCATE FOR cve_per = regtrab[i]
               *  IF 
            *  ENDIF
            bandproc = dialogo("Procede Alta? (S/N)")
            IF bandproc = "S"
              SELECT 4
              APPEND BLANK
              REPLACE cve_per WITH clave
              REPLACE fec_ini_va WITH CTOD(vfec_ini_va)
              REPLACE fec_fin_va WITH CTOD(vfec_fin_va)
              REPLACE n_dias_eje WITH vn_dias_eje
              REPLACE anio_regs WITH VAL(SUBSTR(DTOC(DATE()),7,2))
            ELSE
              ponerror("Operacion Cancelada")
            ENDIF
          ELSE
            ponerror("Operacin Cancelada")
          ENDIF
        ELSE
          ponerror("Vacaciones Agotadas")
        ENDIF
      ELSE
        ponerror("Antigedad menor a 1 ao")
      ENDIF
    ENDIF
   ENDIF
  ENDIF
  continua=dialogo("Realizar otra Alta (S/N)?") 
ENDDO
CLOSE ALL
RETURN


*************************************************************
*PROCEDIMIENTO QUE REALIZA CAMBIOS EN LAS VACACIONES DEL TRABAJADOR
PROCEDURE CAMBVACTRA

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE vacactra
  SELECT 3
  USE datos_pe
  SELECT 4
  USE c_per_va
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    @2,1 CLEAR TO 4,79
    SELECT 1
    LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
    @3,14 SAY "TRABAJADOR: "+TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s) 
    IF band_cve = .T.
      ****EVALUA EL NUMERO DE VACACIONES A LAS CUALES TIENE DERECHO EL TRAB.
      SELECT 3
      LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
      vfech_ingr = DTOC(fech_ingr)
      antigu = antig(vfech_ingr)
      @17,10 SAY "Antigedad del trabajador: "
      @17,37 SAY antigu
      anios = VAL(SUBSTR(antigu,1,2))
      IF anios > 0
        SELECT 4
        GO TOP
        ***EVALUA DIAS EJERCIDOS Y DISPONIBLES DE ACUERDO A ANTIGUEDAD****
        LOCATE FOR desde >= anios
        vnum_d_vac = num_d_vac
        @18,10 SAY "Numero de das correspondientes : "
        @18,43 SAY vnum_d_vac
        SELECT 2
        SUM(n_dias_eje) TO vn_dias_eje FOR cve_per = vcve_per
        totdias = diasejer(anios)
        diasdisp = totdias - vn_dias_eje
        @19,10 SAY "Das disponibles: "
        @19,28 SAY diasdisp
        @4,1 CLEAR TO 10,71
        IF diasdisp > 0
          SELECT vacactra
          SET FILTER TO cve_per = vcve_per 
          COPY TO vacact1
          USE vacact1
          INDEX ON cve_per TO cve_per1
          USE vacact1 INDEX cve_per1
          TITUL := {"FECHA_INICIO","FECHA_TERMINO","NUMERO DE DIAS","AO REGISTRO"}
          CAMPOS := {"FEC_INI_VA","FEC_FIN_VA","N_DIAS_EJE","ANIO_REGS"}
          color="W+/BG+,B+/W"
          SETCOLOR(color)
          MARCMENU(5,4,15,72,color)
          DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
          SET COLOR TO W+/BG+,B+/W
          IF (LASTKEY()=-9)
            fecha_ini = &campo_sel
            vfec_ini_v = DTOC(fecha_ini)
            CLOSE ALL
            USE vacactra
            LOCATE FOR cve_per = vcve_per .AND. fec_ini_va = CTOD(vfec_ini_v)
            vfec_fin_v = DTOC(fec_fin_va)
            vn_dias_eje = n_dias_eje
            vanio_regs = anio_regs
            @20,10 SAY "Das de Vacaciones: " GET vn_dias_eje PICTU "99" VALID .NOT. vn_dias_eje = 0
            @21,10 SAY "Fecha Inicial: " GET vfec_ini_v PICTU "99/99/99"
            @22,10 SAY "Fecha Final: " GET vfec_fin_v PICTU "99/99/99"
            READ
            IF LASTKEY() <> 27
              ****EVALUA SI EXISTEN TRABAJADORES CON MISMO PUESTO CON VACACIONES***
              USE plantill
              LOCATE FOR cve_per = clave 
              vcve_puest = cve_puest
              vcve_area = cve_area
              GO TOP
              COUNT FOR cve_puest = vcve_puest .AND. cve_area = vcve_area TO totregs
              IF totregs > 0
                ***PENDIENTE LA EVALUACION DE TRABAJADORES CON MISMO PUESTO Y AREA
                bandproc = dialogo("Procede Cambio? (S/N)")
                IF bandproc = "S"
                  CLOSE ALL
                  USE vacactra
                  @2,10 say vfec_ini_v + " " + vfec_fin_v + " " + STR(vn_dias_eje)
                  LOCATE FOR cve_per = vcve_per .AND. fec_ini_va = CTOD(vfec_ini_v)
                  REPLACE cve_per WITH clave
                  REPLACE fec_ini_va WITH CTOD(vfec_ini_v)
                  REPLACE fec_fin_va WITH CTOD(vfec_fin_v)
                  REPLACE n_dias_eje WITH vn_dias_eje
                  REPLACE anio_regs WITH VAL(SUBSTR(DTOC(DATE()),7,2))
                ELSE
                  ponerror("Operacion Cancelada")
                ENDIF
              ELSE
                ponerror("Operacin Cancelada")
              ENDIF
            ENDIF
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  ENDIF        
  continua=dialogo("Realizar otro Cambio (S/N)?") 
ENDDO
CLOSE ALL
RETURN




*************************************************************
*PROCEDIMIENTO QUE REALIZA BAJA DE VACACIONES DEL TRABAJADOR
PROCEDURE BAJAVACTRA

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE vacactra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    @2,1 CLEAR TO 4,79
    SELECT 1
    LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
    @3,14 SAY "TRABAJADOR: "+TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s)     
    IF band_cve = .T.
        SELECT vacactra
        SET FILTER TO cve_per = vcve_per 
        COPY TO vacact1
        USE vacact1
        INDEX ON cve_per TO cve_per1
        USE vacact1 INDEX cve_per1
        TITUL := {"FECHA_INICIO","FECHA_TERMINO","NUMERO DE DIAS","AO REGISTRO"}
        CAMPOS := {"FEC_INI_VA","FEC_FIN_VA","N_DIAS_EJE","ANIO_REGS"}
        color="W+/BG+,B+/W"
        SETCOLOR(color)
        @20,1 CLEAR TO 21,79
        MARCMENU(5,4,15,72,color)
        DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
        SET COLOR TO W+/BG+,B+/W
        IF (LASTKEY()=-9)
          vfec_ini_v = &campo_sel
          SELECT 2
          LOCATE FOR cve_per = vcve_per .AND. fec_ini_va = vfec_ini_v
          vfec_fin_v = fec_fin_va
          vn_dias_eje = n_dias_eje
          vanio_regs = anio_regs
          @18,10 SAY "Das de Vacaciones: " 
          @18,30 SAY vn_dias_eje
          @19,10 SAY "Fecha Inicial: " 
          @19,25 SAY vfec_ini_v 
          @20,10 SAY "Fecha Final: " 
          @20,24 SAY vfec_fin_v 
          respuesta = dialogo("Borrar Vacaciones? (S/N)")
          IF respuesta = "S"
            USE vacactra
            LOCATE FOR cve_per = vcve_per .AND. fec_ini_va = vfec_ini_v
            registro = RECNO()
            GO registro
            DELETE
            PACK
          ELSE
            ponerror("Operacin Cancelada")
          ENDIF
        ENDIF
    ENDIF
  ENDIF        
  continua=dialogo("Realizar otra Baja (S/N)?") 
ENDDO
CLOSE ALL
RETURN


*************************************************************
*PROCEDIMIENTO QUE REALIZA EL ALTA DE DIAS ECONOMICOS DE UN TRABAJADOR
PROCEDURE ALTADIASEC

continua = "S"
DO WHILE continua = "S"
  vnum_dias_e = 0
  SELECT 1
  USE nombres
  SELECT 2
  USE ausentra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,19,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    IF band_cve = .T.
        SELECT 2
        SUM (num_dias_e) TO totdias FOR cve_per = vcve_per .AND. anio_inasi = VAL(SUBSTR(DTOC(DATE()),7,2))
        IF totdias > 24
          ponerror("Das Econmicos Agotados")
        ELSE
          @9,10 SAY "Nmero de das econmicos" GET vnum_dias_e PICTU "99" VALID .NOT. vnum_dias_e = 0
          READ
          IF LASTKEY() = 27
            ponerror("Operacin Cancelada")
          ELSE
            IF (totdias + vnum_dias_e > 24)
              ponerror("Das Econmicos exceden a los permitidos")
            ELSE
              SELECT 2
              APPEND BLANK
              REPLACE cve_per WITH vcve_per
              REPLACE num_dias_e WITH vnum_dias_e
              REPLACE anio_inasi WITH VAL(SUBSTR(DTOC(DATE()),7,2))
            ENDIF
          ENDIF
        ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otra Alta (S/N)?") 
ENDDO
CLOSE ALL
RETURN


***F3 PARA REALIZAR BAJA
*************************************************************
*PROCEDIMIENTO QUE ELIMINA DIAS ECONOMICOS DEL TRABAJADOR
PROCEDURE BAJADIASEC

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE ausentra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    @2,1 CLEAR TO 4,79
    SELECT 1
    LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
    @3,14 SAY "TRABAJADOR: "+TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s) 
    IF band_cve = .T.
        SELECT ausentra
        SET FILTER TO cve_per = vcve_per 
        COPY TO ausent1
        USE ausent1
        INDEX ON cve_per TO cve_per1
        USE ausent1 INDEX cve_per1
        TITUL := {"DIAS ECONOMICOS","AO REGISTRO"}
        CAMPOS := {"NUM_DIAS_E","ANIO_INASI"}
        color="W+/BG+,B+/W"
        SETCOLOR(color)
        @21,1 CLEAR TO 21,79
        MARCMENU(5,4,15,71,color)
        DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
        SET COLOR TO W+/BG+,B+/W
        IF (LASTKEY()=-9)
          vnum_dias_e = &campo_sel
          SELECT 2
          LOCATE FOR cve_per = vcve_per .AND. num_dias_e = vnum_dias_e
          vanio_inasis = anio_inasis
          @18,10 SAY "Das Econmicos: " 
          @18,27 SAY vnum_dias_e
          @19,10 SAY "Ao de Registro: " 
          @19,27 SAY vanio_inasis
          respuesta = dialogo("Borrar Das Econmicos? (S/N)")
          IF respuesta = "S"
            USE ausentra
            LOCATE FOR cve_per = vcve_per .AND. num_dias_e = vnum_dias_e
            registro = RECNO()
            GO registro
            DELETE
            PACK
          ELSE
            ponerror("Operacin Cancelada")
          ENDIF
        ENDIF
    ENDIF
  ENDIF        
  continua=dialogo("Realizar otra Baja (S/N)?") 
ENDDO
CLOSE ALL
RETURN


***F10 PARA REALIZAR CAMBIO
*************************************************************
*PROCEDIMIENTO QUE REALIZA CAMBIO DE DIAS ECONOMICOS DEL TRABAJADOR
PROCEDURE CAMBDIASEC

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE ausentra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    @2,1 CLEAR TO 4,79
    SELECT 1
    LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
    @3,14 SAY "TRABAJADOR: "+TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s) 
    IF band_cve = .T.
        SELECT ausentra
        SET FILTER TO cve_per = vcve_per 
        COPY TO ausent1
        USE ausent1
        INDEX ON cve_per TO cve_per1
        USE ausent1 INDEX cve_per1
        TITUL := {"DIAS ECONOMICOS","AO REGISTRO"}
        CAMPOS := {"NUM_DIAS_E","ANIO_INASI"}
        color="W+/BG+,B+/W"
        SETCOLOR(color)
        @21,1 CLEAR TO 21,79
        MARCMENU(5,4,15,72,color)
        DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
        SET COLOR TO W+/BG+,B+/W
        IF (LASTKEY()=-9)
          vnum_dias_e:=nvo_dias:=&campo_sel
          SELECT 2
          LOCATE FOR cve_per = vcve_per .AND. num_dias_e = vnum_dias_e
          vanio_inasis = anio_inasis
          @18,10 SAY "Das Econmicos: " GET nvo_dias PICTU "99" VALID .NOT. nvo_dias = 0
          @19,10 SAY "Ao de Registro: " GET vanio_inasis PICTU "99" VALID .NOT. vanio_inasis = 0
          READ
          IF LASTKEY() = 27
            ponerror("Operacin Cancelada")
          ELSE
            bandcont = .T.
            IF nvo_dias > vnum_dias_e
              SUM (num_dias_e) TO totdias FOR cve_per = vcve_per .AND. anio_inasis = VAL(SUBSTR(DTOC(DATE()),7,2))
              totdias1 = totdias + (nvo_dias - vnum_dias_e)
              IF totdias1 > 24
                ponerror("Das Econmicos exceden a los permitidos")
                bandcont = .F.
              ELSE
                bandcont = .T.
              ENDIF
            ENDIF
            IF bandcont = .T.
              USE ausentra
              LOCATE FOR cve_per = vcve_per .AND. num_dias_e = vnum_dias_e
              REPLACE num_dias_e WITH nvo_dias
              REPLACE anio_inasis WITH vanio_inasis
            ENDIF
          ENDIF
        ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otro Cambio (S/N)?") 
ENDDO
CLOSE ALL
RETURN

*************************************************************
*PROCEDIMIENTO QUE REALIZA EL ALTA DE INCAPACIDADES DE UN TRABAJADOR
PROCEDURE ALTAINCA

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE incatra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,19,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    vnum_dias_in:=0
    vfec_ini_in:=vfec_fin_in:=SPACE(8)
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    IF band_cve = .T.
        @9,10 SAY "Fecha Inicio Incapacidad" GET vfec_ini_in PICTU "99/99/99" 
        @10,10 SAY "Fecha Fin Incapacidad" GET vfec_fin_in PICTU "99/99/99" 
        @11,10 SAY "Das de Incapacidad" GET vnum_dias_in PICTU "99" VALID .NOT. vnum_dias_in = 0
        READ
        IF LASTKEY() = 27
          RETURN
        ELSE
          SELECT 2
          APPEND BLANK
          REPLACE cve_per WITH vcve_per
          REPLACE fec_ini_in WITH CTOD(vfec_ini_in)
          REPLACE fec_fin_in WITH CTOD(vfec_fin_in)
          REPLACE num_dias_in WITH vnum_dias_in
        ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otra Alta (S/N)?") 
ENDDO
CLOSE ALL
RETURN


***F10 PARA REALIZAR CAMBIO
*************************************************************
*PROCEDIMIENTO QUE REALIZA CAMBIO EN INCAPACIDADES DEL TRABAJADOR
PROCEDURE CAMBINCAP

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE incatra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    @2,1 CLEAR TO 4,79
    SELECT 1
    LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
    @3,14 SAY "TRABAJADOR: "+TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s) 
    IF band_cve = .T.
        SELECT incatra
        SET FILTER TO cve_per = vcve_per 
        COPY TO incatra1
        USE incatra1
        INDEX ON cve_per TO cve_per1
        USE incatra1 INDEX cve_per1
        TITUL := {"FECHA INICIAL","FECHA FINAL","DIAS INCAPACIDAD"}
        CAMPOS := {"FEC_INI_IN","FEC_FIN_IN","NUM_DIAS_IN"}
        color="W+/BG+,B+/W"
        SETCOLOR(color)
        @21,1 CLEAR TO 21,79
        MARCMENU(5,4,15,72,color)
        DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
        SET COLOR TO W+/BG+,B+/W
        IF (LASTKEY()=-9)
          fecha_ini:=&campo_sel
          vfec_ini_in = DTOC(fecha_ini)
          SELECT 2
          LOCATE FOR cve_per = vcve_per .AND. fec_ini_in = CTOD(vfec_ini_in)
          vfec_fin_in = DTOC(fec_fin_in)
          vnum_dias_in = num_dias_in
          @18,10 SAY "Fecha Inicio Incapacidad: " GET vfec_ini_in PICTU "99/99/99"
          @19,10 SAY "Fecha Fin Incapacidad: " GET vfec_fin_in PICTU "99/99/99" 
          @20,10 SAY "Das de Incapacidad" GET vnum_dias_in PICTU "99" VALID .NOT. vnum_dias_in = 0
          READ
          IF LASTKEY() = 27
            ponerror("Operacin Cancelada")
          ELSE
            USE incatra
            LOCATE FOR cve_per = vcve_per .AND. fec_ini_in = fecha_ini
            REPLACE fec_ini_in WITH CTOD(vfec_ini_in)
            REPLACE fec_fin_in WITH CTOD(vfec_fin_in)
            REPLACE num_dias_in WITH vnum_dias_in
          ENDIF
        ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otro Cambio (S/N)?") 
ENDDO
CLOSE ALL
RETURN


****PROCEDIMIENTO QUE REALIZA EL ALTA DE FALTAS Y RETARDOS
PROCEDURE falalta(alta)
*alta igual a 0 si son Faltas, 1 si son Retardos

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE AUSENTRA
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    IF band_cve = .T.
      IF alta = 0
        cadena = "Faltas"
      ELSE
        cadena = "Retardos"
      ENDIF
      vnumero = 0
      @9,30 SAY "Nmero de "+ cadena +":" GET vnumero PICTU "99"
      READ
      IF LASTKEY() = 27
        RETURN
      ELSE
          SELECT 2
          APPEND BLANK
          REPLACE cve_per WITH vcve_per
          IF alta = 0 
            REPLACE num_faltas WITH vnumero
          ELSE
            REPLACE num_retard WITH vnumero
         ENDIF
         REPLACE anio_inasi WITH VAL(SUBSTR(DTOC(DATE()),7,2))
      ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otra Alta (S/N)?") 
ENDDO
CLOSE ALL
RETURN


***F10 PARA REALIZAR CAMBIO
*************************************************************
*PROCEDIMIENTO QUE REALIZA CAMBIO EN FALTAS Y RETADOS DEL TRABAJADOR
PROCEDURE FALCAMB(cambio)

continua = "S"
DO WHILE continua = "S"
  SELECT 1
  USE nombres
  SELECT 2
  USE ausentra
  clave = SPACE(8)
  color="W+/BG+,B+/W"
  SETCOLOR(color)
  @2,1 CLEAR TO 23,79
  marcmenu(3,7,10,71,"W+/BG")
  @5,35 SAY "TRABAJADOR"
  @7,26 SAY "Clave: "
  SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})      
  @7,33 GET clave PICTURE "@!" VALID .NOT. clave = " "
  READ
  IF LASTKEY()=27
    RETURN
  ELSE
    vcve_per = clave
    band_cve = saca_tipo2("nombres",vcve_per,"Trabajador","W",8,15,.T.)
    @2,1 CLEAR TO 4,79
    SELECT 1
    LOCATE FOR cve_per = vcve_per .AND. tipo = "W"
    @3,14 SAY "TRABAJADOR: "+TRIM(paterno)+" "+TRIM(materno)+" "+TRIM(nombre_s) 
    IF band_cve = .T.
        SELECT ausentra
        IF cambio = 0
          SET FILTER TO cve_per = vcve_per .AND. num_faltas > 0
        ELSE
          SET FILTER TO cve_per = vcve_per .AND. num_retard > 0
        ENDIF
        COPY TO ausent1
        USE ausent1
        INDEX ON cve_per TO cve_per1
        USE ausent1 INDEX cve_per1
        IF cambio = 0
          TITUL := {"NUMERO DE FALTAS","AO DE REGISTRO"}
          CAMPOS := {"NUM_FALTAS","ANIO_INASI"}
        ELSE
          TITUL := {"NUMERO DE RETARDOS","AO DE REGISTRO"}
          CAMPOS := {"NUM_RETARD","ANIO_INASI"}
        ENDIF
        color="W+/BG+,B+/W"
        SETCOLOR(color)
        MARCMENU(5,4,15,72,color)
        DBEDIT(6,5,14,70,CAMPOS,"fun_ed5",.F.,TITUL)
        SET COLOR TO W+/BG+,B+/W
        IF (LASTKEY()=-9)
          vnumero:=&campo_sel
          USE ausentra
          IF cambio = 0
             LOCATE FOR cve_per = vcve_per .AND. num_faltas = vnumero WHILE num_faltas > 0
             registro = RECNO()
             cadena = "Faltas"
          ELSE
             LOCATE FOR cve_per = vcve_per .AND. num_retard = vnumero WHILE num_retard > 0
             registro = RECNO()
             cadena = "Retardos"
          ENDIF
          vanio = anio_inasi
          @19,30 SAY "Nmero de "+ cadena +":" GET vnumero PICTU "99"
          @20,30 SAY "Ao de registro:" GET vanio PICTU "99"
          READ
          @22,10 say STR(vnumero)
          @22,50 say STR(vanio)
          IF LASTKEY() = 27
            ponerror("Operacin Cancelada")
          ELSE
            USE ausentra
            *LOCATE FOR cve_per = vcve_per .AND. num_faltas = vnumero
            GO registro
            REPLACE cve_per WITH vcve_per
            IF cambio = 0 
                REPLACE num_faltas WITH vnumero
            ELSE
                REPLACE num_retard WITH vnumero
            ENDIF
            REPLACE anio_inasi WITH vanio
          ENDIF
        ENDIF
    ENDIF
  ENDIF
  continua=dialogo("Realizar otro Cambio (S/N)?") 
ENDDO
CLOSE ALL
RETURN

****FUNCION QUE CALCULA EL NUMERO DE DIAS DE VACACIONES QUE
* UN TRABAJADOR DEBIO HABER TOMADO DE ACUERDO A SU ANTIGEDAD
FUNCTION diasejer(anios)

SELECT c_per_va
registros = RECCOUNT()
dias = 0
FOR i = 1 TO registros
  GOTO i
  IF desde <= anios
    IF desde < hasta
      periodo = (hasta - desde) + 1
      dias = dias + (periodo * num_d_vac)
    ELSE
      dias = dias + num_d_vac
    ENDIF
  ELSE
    i = registros
  ENDIF
NEXT
RETURN(dias)

