****************************************************************************
** PROCEDIMIENTO GENERAL DE SELECCION DE TRABAJADORES PARA PROMOCION
****************************************************************************
PROCEDURE sele_int()

DO WHILE .T.
   indices()
   USE sol_pers NEW
   INDEX ON folio TO indsol
   USE catprin INDEX indprin NEW
   SET COLOR TO "W+/BG+,B+/W"
   DO WHILE .T.
      limpiamenu(2,1,22,79)
      barstatus(4)
      vfolio=sel_folio()
      IF vfolio=NIL
         CLOSE ALL
         RETURN
      ELSE
         clave_puesto=busca_datos_req(vfolio)
         resp = dialogo("Seleccin para este puesto? S/N")
         IF resp="S"
            continua = .T.
            EXIT
         ELSE
            limpiamenu(5,15,23,79)
            continua = .F.
            EXIT
         ENDIF
      ENDIF
   ENDDO
   IF continua = .T.
      ejecuta="S"
      USE selfin2 NEW
      LOCATE FOR folio=VAL(vfolio)
      IF FOUND()
         ponerror("Ya existen candidatos para este folio")
         ejecuta=dialogo("Desea actualizar datos? S/N")
      ELSE
         ejecuta="S"
      ENDIF
      IF ejecuta="S"
         busca_promo()
         USE pues_tmp NEW
         INDEX ON cve_per+cve_esp TO indpuetm
         totpues=RECCOUNT()
         USE prom_tmp NEW
         INDEX ON cve_per+cve_esp TO indprotm
         totprom=RECCOUNT()
         IF totpues<>0 .OR. totprom<>0      
            JOIN WITH pues_tmp TO promsels FOR pues_tmp->cve_esp = prom_tmp->cve_esp;
            FIELDS cve_per,cve_esp,valor,cve_uni
            SELECT selfin2
            SET FILTER TO folio=VAL(vfolio)
            DELETE ALL
            PACK
            USE promsels NEW
            no_esp=0
            totregsel=LASTREC()
            FOR cont=1 TO totregsel
                SELECT promsels
                GOTO cont
                cve_pro1=cve_per
                COUNT FOR cve_per=cve_pro1 TO no_esp
                guarda_promo_sel(vfolio,cve_pro1,no_esp)
            NEXT
         ENDIF
      ENDIF
      CLOSE ALL
      DO WHILE .T.
         USE selfin2 NEW
         INDEX ON num_esp TO indself2
         clave_prom=muestra2_gral(4,3,19,76,vfolio,0)
         DO CASE
            CASE clave_prom = NIL
                 IF LASTKEY()=27
                    EXIT
                 ENDIF
            CASE clave_prom <> NIL
                 IF LASTKEY()=13
                    limpiamenu(3,2,22,78)
                    consulta_prom_detallada(clave_prom,clave_puesto)
                 ELSE
                    IF LASTKEY() = -4
                       clave_prom=NIL
                    ENDIF
                 ENDIF
         ENDCASE
     ENDDO
   ENDIF
ENDDO

*************************************************************************
** PROCEDIMIENTO PARA CONSULTAR EN DETALLE LAS ESPEC. DE UN TRABAJADOR PROM.
*************************************************************************
PROCEDURE consulta_prom_detallada(clave_prom,clave_puesto)

USE promsels NEW
INDEX ON cve_esp TO indprose
USE plantilla NEW
INDEX ON cve_per TO indcandi
USE catprin INDEX indprin NEW
USE prom_tmp NEW
INDEX ON cve_esp TO indprotm
USE pues_tmp NEW
INDEX ON cve_esp TO indpuetm
DO WHILE .T.
   barstatus(3)
   SELECT selfin2
   LOCATE FOR cve_per=clave_prom
   nomb_prom=nombre
   SELECT plantilla
   SEEK clave_prom
   puesto=cve_puest
   SELECT catprin
   SEEK clave_puesto
   nomb_puesto=nom_obj
   SET COLOR TO "W+/BG+,B+/W"
   @2,5 SAY "Trabajador seleccionado para el puesto: " + clave_puesto
   @4,2 SAY "Clave: " + clave_prom + " Nombre Trabajador: " + nomb_prom
   @6,2 SAY "Puesto Actual: " + puesto + " " + nomb_puesto
   clave_det=muestra2_detalle_prom(8,4,19,73,clave_prom)
   IF clave_det=NIL
      CLOSE ALL
      RETURN
   ENDIF
ENDDO


****************************************************************************
** PROCEDIMIENTO QUE DESPLIEGA LOS PROMOCIONADOS SELECCIONADOS (GENERAL)
****************************************************************************
PROCEDURE muestra2_gral(y1,x1,y2,x2,vfolio,tecla)

totpromo=0
DECLARE campos[5]
PUBLIC clave
clave = NIL
IF tecla = -2 
   pantsel = SAVESCREEN(0,0,24,79)
ENDIF
SELECT selfin2
SET FILTER TO
SET FILTER TO folio=VAL(vfolio)
SET COLOR TO W+/BG+,B+/W
limpiamenu(2,1,2,79)
barstatus(14)
campos[1]="fecha_pro"
campos[2]="STRZERO(folio,6,0)"
campos[3]="cve_per"
campos[4]="nombre"
campos[5]="STR(num_esp)"
COUNT FOR folio=VAL(vfolio) TO totpromo
IF totpromo >= 1
   limpiamenu(2,1,2,79)
   GO TOP
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED4",;
     {"99-99-99","XXXXXX","XXXXXXXX","XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",""},;
     {"PROCESO","FOLIO REQ.","IDENTIF.","NOMBRE TRABAJADOR","N ESP."},"","","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ELSE
     IF (LASTKEY()=-4)
        marcmenu(11,21,13,49)
        SET COLOR TO "W+/BG+,B+/W"
        @12,26 SAY "IMPRIMIENTO REPORTE..."
        REPORT FORM selint TO PRINT NOCONSOLE
        limpiamenu(11,21,15,51)
        clave=NIL
     ENDIF
   ENDIF
ELSE
   ponerror("No hay candidatos para el puesto")
   clave=NIL
ENDIF
IF tecla = -2
   limpiamenu(y1,x1,y2+2,x2+2)
   RESTSCREEN(0,0,24,79,pantsel)
ENDIF

RETURN(clave)


****************************************************************************
** PROCEDIMIENTO QUE GUARDA LOS DATOS DE LOS CANDIDATOS SELECCIONADOS
****************************************************************************
PROCEDURE guarda_promo_sel(vfolio,cve_pro1,no_esp)     

SELECT selfin2
LOCATE FOR folio=VAL(vfolio) .AND. cve_per=cve_pro1
IF .NOT. FOUND()
   USE nombres INDEX indnombr NEW
   SEEK cve_pro1
   IF FOUND()
      nom_candi=TRIM(paterno) + " " + TRIM(materno) + " " + TRIM(nombre_s)
   ELSE
      nom_candi=" "
   ENDIF
   CLOSE nombres
   SELECT selfin2
   APPEND BLANK 
   REPLACE fecha_pro WITH DATE()
   REPLACE folio WITH VAL(vfolio)
   REPLACE cve_per WITH cve_pro1
   REPLACE nombre WITH nom_candi
   REPLACE num_esp WITH no_esp
   RETURN
ENDIF


****************************************************************************
***PROCEDIMIENTO QUE SELECCIONA LAS ESPECIFICACIONES DEL PUESTO SELECCIONADO
*** Y LOS TRABAJADORES EXISTENTES PARA PROMOCION
****************************************************************************

PROCEDURE busca_promo()

USE asig_esp NEW       // nuevo
SET FILTER TO
SET FILTER TO cve_per = clave_puesto
COPY TO pues_tmp ALL
SET FILTER TO
SET FILTER TO tipo="W"
COPY TO prom_tmp ALL
CLOSE asig_esp         // nuevo
RETURN
   
****************************************************************************
** PROCEDIMIENTO QUE DESPLIEGA LOS TRABAJADORES SELECCIONADOS (DETALLADO)
****************************************************************************
PROCEDURE muestra2_detalle(y1,x1,y2,x2,clave_prom)

totpromo=0
DECLARE campos[5]
PRIVATE clave
clave= NIL
SELECT promsels
SET RELATION TO cve_esp INTO pues_tmp
SET FILTER TO
SET FILTER TO cve_per=clave_prom
SET COLOR TO W+/BG+,B+/W
campos[1]="pues_tmp->cve_esp"
campos[2]="pues_tmp->valor"
campos[3]="pues_tmp->cve_uni"
campos[4]="prom_tmp->valor"
campos[5]="prom_tmp->cve_uni"
COUNT FOR cve_per=clave_prom TO totpromo
IF totpromo >= 1
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   GO TOP                  
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED3",;
     {"XXXXXXXX","9999.99","XXXXXXXX","9999.99","XXXXXXXX"},;
     {"CLAVE ESP.","VALOR PUESTO","MEDIDA","VALOR CAND.","MEDIDA"},"","","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ELSE
      IF (LASTKEY()=-4)
          marcmenu(11,21,13,49)
          SET COLOR TO "W+/BG+,B+/W"
          @12,26 SAY "IMPRIMIENTO REPORTE..."
          REPORT FORM seldetin TO PRINT NOCONSOLE
          limpiamenu(11,21,15,51)
          clave = NIL
      ENDIF
   ENDIF
ELSE
   ponerror("No hay candidatos para el puesto")
   clave=NIL
ENDIF
RETURN(clave)

