************************************************************************
** PROCEDIMIENTO QUE LLAMA A LAS FUNCIONES CORRESPONDIENTES DE ACUERDO
** AL PROCESO A REALIZAR PARA UN CANDIDATO
************************************************************************
PROCEDURE procesa_candi(tipo_man)

PUBLIC clave
INDICES()
USE catprin INDEX indprin NEW
USE nombres INDEX indnombr NEW
USE direc INDEX inddirec NEW
USE candidat INDEX indcandi NEW
USE datos_pe INDEX inddatpe NEW
USE c_fue_re INDEX indfuere NEW
SET COLOR TO W/BG+,B+/W
DO CASE
   CASE tipo_man = "A" // PARA ALTA
        DO WHILE .T.
           manten_candi("A") 
           IF LASTKEY()=27
              CLOSE ALL
              RETURN
           ENDIF
        ENDDO
   CASE tipo_man = "C" // PARA CAMBIO
        DO WHILE .T.
           clave_candi=pide_clave_candi("C")
           IF clave_candi <> NIL
               manten_candi("C",clave_candi) 
           ELSE
               CLOSE ALL
               RETURN
           ENDIF
        ENDDO
   CASE tipo_man = "D" // PARA DESPLIEGUE
        resp="S"
        DO WHILE resp="S"
           clave_candi=pide_clave_candi("D")
           IF LASTKEY()=27
              CLOSE ALL
              resp="N"
              RETURN
           ELSE
              resp=desple_candi("D",clave_candi)
           ENDIF
        ENDDO
ENDCASE


*************************************************************************
** PROCEDIMIENTO PARA DAR DE ALTA Y CAMBIAR LOS DATOS DE UN CANDIDATO
*************************************************************************
PROCEDURE manten_candi(tipo_man,clave_candi) 
    *** tipo_man puede ser "A" si es Alta o "C" si es Cambio
DO WHILE .T.
   barstatus(7)
   SET COLOR TO W/BG+,B+/W
   marcmenu(2,1,20,77)
   SET COLOR TO W/BG+,B+/W
   STORE SPACE(8) TO clave
   inicializa_var_candi(tipo_man,clave_candi)
   resp="N"
   DO WHILE resp="N"
      SETKEY(-1,{||cat_gral(6,3,20,56,"catprin","P")})
      @3,3 SAY "Nombre(s):" GET vnombre_s PICTURE "@S12!" VALID .NOT. vnombre_s=" " 
      @3,28 SAY "A.Paterno:" GET vpaterno PICTURE "@S12!" VALID .NOT. vpaterno=" "
      @3,52 SAY "A.Materno:" GET vmaterno PICTURE "@S12!" VALID .NOT. vmaterno=" "
      @5,3 SAY "Puesto Solicitado:" GET clave PICTURE "@!" VALID .NOT. clave=" "
      @5,32 SAY "N Solicitud:" GET vnum_sol PICTURE "999999" VALID .NOT. vnum_sol=0
      IF tipo_man = "A"
         @5,55 SAY "Clave:" GET vcve_per PICTURE "@!" VALID .NOT. vcve_per =" "
      ELSE
         @5,55 SAY "Clave: "+vcve_per         
      ENDIF
      @7,2 SAY "-- DIRECCION " + REPLICATE("-",61)
      @8,3 SAY "Calle:" GET vcalle PICTURE "@S25!" VALID .NOT. vcalle=" "
      @8,39 SAY "Num. Ext.:" GET vnum_ext PICTURE "9999"
      @8,57 SAY "Num. Int.:" GET vnum_int PICTURE "999"
      @10,3 SAY "Colonia:" GET vcolonia PICTURE "@S15!"
      @10,29 SAY "Ciudad:" GET vciudad PICTURE "@S10!" VALID .NOT. vciudad=" " 
      @10,54 SAY "Estado:" GET vestado PICTURE "@S12!"
      @12,3 SAY "C.P.:" GET vcp PICTURE "99999"
      @12,15 SAY "Telfono:" GET vtel PICTURE "9-99-99-99"
      @12,41 SAY "Extensin:" GET vext PICTURE "9999"
      @14,2 SAY "-- DATOS GENERALES "+ REPLICATE("-",55)
      @15,3 SAY "Estado Civil:" GET vedo_civ1 VALID val_gets(2,14,16,19,29)
      @15,40 SAY "Sexo:" GET vsexo1 VALID val_gets(1,14,45,18,55)
      @17,3 SAY "Estatura:" GET vestatura PICTURE "9.99"
      @17,20 SAY "Peso:" GET vpeso PICTURE "999"
      @17,40 SAY "Fecha de Nacimiento:" GET vfech_nac PICTURE "99/99/99" 
      @19,3 SAY "Nacionalidad:" GET vnacionalid PICTURE "@!"
      @19,40 SAY "Reg. Fed. Caus.:" GET vrfc_trab PICTURE "!!!!######-XXX"
      READ
      IF LASTKEY()=27
         limpiamenu(2,1,22,80)
         RETURN
      ELSE
         vcve_puest=clave
         vtipo="K"
         IF vedo_civ1="SEPARADO"
            vestado_civ="E"
         ELSE
            vestado_civ=SUBSTR(vedo_civ1,1,1)
         ENDIF
         vsexo=SUBSTR(vsexo1,1,1)
         vfech_ingr=DATE()
         IF tipo_man="C"
            vfech_nac=CTOD(vfech_nac)
         ENDIF
         pant0=SAVESCREEN(17,30,21,79)
         continua1=valida_cves(vcve_puest,"P",tipo_man)
         continua2=valida_cves(vcve_per,"K",tipo_man)
         IF continua1=.T. .AND. continua2=.T.
            * REGISTRO DE LA FUENTE DE RECLUTAMIENTO
            IF tipo_man="A"
               vcve_fue=reg_fuente()
            ENDIF
            resp=dialogo("Es correcto? S/N ")
            RESTSCREEN(17,30,21,79,pant0)
            IF resp="S"
               guarda_datos_candi(tipo_man)
               limpiamenu(2,1,22,80)
               RETURN
            ELSE
               IF tipo_man="C"
                  vfech_nac=DTOC(vfech_nac)
               ENDIF
            ENDIF
         ELSE
            resp="N"
         ENDIF
      ENDIF
   ENDDO
ENDDO

*************************************************************************
** FUNCION PARA DESPLEGAR CAMBIAR LOS DATOS DE UN CANDIDATO
*************************************************************************
FUNCTION desple_candi(tipo_man,clave_candi) 
    
barstatus(5)
SET COLOR TO W/BG+,B+/W
marcmenu(2,1,20,77)
SET COLOR TO W/BG+,B+/W
STORE SPACE(8) TO clave
inicializa_var_candi(tipo_man,clave_candi)
@3,3 SAY "Nombre(s): "+vnombre_s 
@3,28 SAY "A.Paterno: "+vpaterno 
@3,52 SAY "A.Materno: "+vmaterno 
@5,3 SAY "Puesto Solicitado: "+clave 
@5,32 SAY "N Solicitud: "+STR(vnum_sol) 
@5,55 SAY "Clave: "+ vcve_per         
@7,2 SAY "-- DIRECCION " + REPLICATE("-",61)
@8,3 SAY "Calle: "+vcalle 
@8,39 SAY "Num. Ext.: "+STR(vnum_ext)
@8,57 SAY "Num. Int.: "+STR(vnum_int)
@10,3 SAY "Colonia: "+vcolonia
@10,29 SAY "Ciudad: "+vciudad 
@10,54 SAY "Estado: "+vestado
@12,3 SAY "C.P.: "+STR(vcp) 
@12,15 SAY "Telfono: "+vtel
@12,41 SAY "Extensin: "+STR(vext)
@14,2 SAY "-- DATOS GENERALES "+ REPLICATE("-",55)
@15,3 SAY "Estado Civil: "+vedo_civ1
@15,40 SAY "Sexo: "+vsexo1 
@17,3 SAY "Estatura: "+STR(vestatura)
@17,20 SAY "Peso: "+STR(vpeso)
@17,40 SAY "Fecha de Nacimiento: "+vfech_nac
@19,3 SAY "Nacionalidad: "+vnacionalid
@19,40 SAY "Reg. Fed. Caus.: "+vrfc_trab
ponerror("Presione cualquier tecla")
pant0=SAVESCREEN(17,30,21,79)
resp=dialogo("Consultar otro candidato? S/N ")
RESTSCREEN(17,30,21,79,pant0)
limpiamenu(2,1,22,80)
RETURN(resp)



*************************************************************************
** PROCEDIMIENTO QUE INICIALIZA LAS VARIABLES RELACIONADAS CON EL CANDI.
*************************************************************************
PROCEDURE inicializa_var_candi(tipo_man,clave_candi)

***** Definiendo las variables

PUBLIC vnum_sol
PUBLIC vtipo
PUBLIC vcve_puest
PUBLIC vcve_per
PUBLIC vnombre_s
PUBLIC vpaterno
PUBLIC vmaterno
PUBLIC vcalle
PUBLIC vnum_ext
PUBLIC vnum_int
PUBLIC vcolonia
PUBLIC vcp
PUBLIC vciudad
PUBLIC vestado
PUBLIC vtel
PUBLIC vext
PUBLIC vestado_civ
PUBLIC vsexo
PUBLIC vestatura
PUBLIC vpeso
PUBLIC vfech_nac
PUBLIC vnacionalid
PUBLIC vrfc_trab
PUBLIC vfech_ingr
PUBLIC vres_examed
PUBLIC veval_candi
PUBLIC vedo_civ1
PUBLIC vsexo1
PUBLIC vcve_fue

**** Inicializando las variables por primera vez
IF tipo_man = "A" 
   STORE SPACE(11) TO vedo_civ1
   STORE SPACE(9) TO vsexo1
   STORE 0 TO vnum_sol
   STORE SPACE(8) TO vcve_puest
   STORE SPACE(1) TO vtipo
   STORE SPACE(8) TO vcve_per
   STORE SPACE(20) TO vnombre_s
   STORE SPACE(20) TO vpaterno
   STORE SPACE(20) TO vmaterno
   STORE SPACE(20) TO vcalle
   STORE 0 TO vnum_ext
   STORE 0 TO vnum_int
   STORE SPACE(20) TO vcolonia
   STORE 0 TO vcp
   STORE SPACE(10) TO vciudad
   STORE SPACE(15) TO vestado
   STORE SPACE(10) TO vtel
   STORE 0 TO vext
   STORE SPACE(1) TO vestado_civ
   STORE SPACE(1) TO vsexo
   STORE 0 TO vestatura
   STORE 0 TO vpeso
   STORE CTOD("  /  /  ") TO vfech_nac
   STORE SPACE(20) TO vnacionalid
   STORE SPACE(14) TO vrfc_trab
   STORE CTOD("  /  /  ") TO vfech_ingr
   STORE SPACE(1) TO vres_examed
   STORE 0 TO veval_candi
   STORE SPACE(8) TO vcve_fue
ELSE
   num_campos=0
   cont_campo=0
   campo_num=0
   campo_alf=" "
   campo_dat=" "
   vnom_campo=" "
   nom_campo=" "
   cont_bases=0
   arr_bases = ARRAY(4)
   *** Construccin de arreglo de tablas a utilizar
   arr_bases[1] = "nombres"
   arr_bases[2] = "direc"
   arr_bases[3] = "datos_pe"
   arr_bases[4] = "candidat"
   FOR cont_bases=1 TO 4
       base=arr_bases[cont_bases]
       SELECT &base
       SEEK clave_candi
       num_campos=FCOUNT()
       FOR cont_campo=1 to num_campos
           nom_campo=FIELD(cont_campo)
           vnom_campo="V"+FIELD(cont_campo)
           tipo_dat=TYPE(FIELD(cont_campo))
           DO CASE
              CASE tipo_dat = "C"
                   campo_alf=&nom_campo
                   STORE campo_alf TO &vnom_campo
              CASE tipo_dat =  "N"
                   campo_num=&nom_campo
                   STORE campo_num to &vnom_campo
              CASE tipo_dat =  "D"
                   campo_dat=DTOC(&nom_campo)
                   STORE campo_dat to &vnom_campo
           ENDCASE
       NEXT
   NEXT
   DO CASE 
      CASE vestado_civ = "S"
           vedo_civ1="SOLTERO"
      CASE vestado_civ = "C"
           vedo_civ1="CASADO"
      CASE vestado_civ = "D"
           vedo_civ1="DIVORCIADO"
      CASE vestado_civ = "V"
           vedo_civ1="VIUDO"
      CASE vestado_civ = "U"
           vedo_civ1="UNION LIBRE"
      CASE vestado_civ = "E"
           vedo_civ1="SEPARADO"
  ENDCASE
  DO CASE
     CASE vsexo = "F"
          vsexo1 = "FEMENINO"
     CASE vsexo = "M"
          vsexo1 = "MASCULINO"
  ENDCASE
  clave=vcve_puest
ENDIF
RETURN

*************************************************************************
** FUNCION QUE DESPLIEGA LOS VALORES VALIDOS PARA SEXO Y ESTADO CIVIL
*************************************************************************
FUNCTION VAL_GETS(tipo_get,y1,x1,y2,x2)
PRIVATE arreglo,reg
PUBLIC sel

arreglo=ARRAY(6)
DO CASE 
   CASE tipo_get = 1  // Arreglo de "Sexo"
        arreglo[1] = "FEMENINO"
        arreglo[2] = "MASCULINO"
   CASE tipo_get = 2  // Arreglo de "Estado Civil"
        arreglo[1] = "CASADO"
        arreglo[2] = "SOLTERO"         
        arreglo[3] = "DIVORCIADO"
        arreglo[4] = "VIUDO"
        arreglo[5] = "UNION LIBRE"
        arreglo[6] = "SEPARADO"
END CASE
pant=SAVESCREEN(y1-1,x1-1,y2+1,x2+1)
marcmenu(y1,x1,y2,x2,"B/W+,W+/B+")
reg=ACHOICE(y1+1,x1+1,y2-1,x2-1,arreglo,"","valida")
DO CASE
   CASE tipo_get = 1 
        vsexo1=arreglo[reg]
   CASE tipo_get = 2
        vedo_civ1=arreglo[reg]
END CASE
limpiamenu(y1-1,x1-1,y2+1,x2+1)
RESTSCREEN(y1-1,x1-1,y2+1,x2+1,pant)
SET COLOR TO W+/BG+,B+/W
RETURN(.T.)


*************************************************************************
** PROCEDIMIENTO PARA ALMACENAR TODOS LOS DATOS DE LOS CANDIDATOS EN
** LAS TABLAS CORRESPONDIENTES
*************************************************************************
PROCEDURE guarda_datos_candi(tipo_man)

**** Definicin de variables
num_campos=0
cont_campo=0
nom_campo=" "
vnom_campo=" "
cont_bases=0
arr_bases=ARRAY(4)
vnum_reclu=0

*** Construccin de arreglo de tablas a utilizar
arr_bases[1] = "nombres"
arr_bases[2] = "direc"
arr_bases[3] = "datos_pe"
arr_bases[4] = "candidat"

FOR cont_bases=1 TO 4
    base=arr_bases[cont_bases]
    SELECT &base
    IF tipo_man = "A"
       APPEND BLANK
    ENDIF
    num_campos=FCOUNT()
    FOR cont_campo=1 to num_campos
        nom_campo=FIELD(cont_campo)
        vnom_campo="V"+FIELD(cont_campo)
        REPLACE &nom_campo WITH &vnom_campo
    NEXT
NEXT
IF tipo_man = "A"
   SELECT c_fue_re
   SEEK vcve_fue
   vnum_reclu = num_reclu + 1
   REPLACE num_reclu WITH vnum_reclu
END IF
RETURN

*************************************************************************
** FUNCION QUE VALIDA LAS CLAVES DEL PUESTO Y LA DE LA PERSONA
*************************************************************************
FUNCTION  valida_cves(vcve,tipo_cve,tipo_man)

DO CASE 
   CASE tipo_cve="P"
        SELECT catprin
        SEEK vcve
        IF FOUND()
           RETURN(.T.)
        ELSE
           ponerror("Clave de puesto inexistente")
           RETURN(.F.)
        ENDIF
   CASE tipo_cve="K"
        IF tipo_man = "A"
           SELECT candidat
           SEEK vcve
           IF FOUND()
              ponerror("Clave asignada existente")
              RETURN(.F.)
           ELSE
              RETURN(.T.)
           ENDIF
        ELSE
           RETURN(.T.)
        ENDIF
ENDCASE

*************************************************************************
** FUNCION QUE SOLICITA LA CLAVE DEL CANDIDATO PARA HACER CAMBIOS
*************************************************************************
FUNCTION pide_clave_candi(tipo_man)

DO WHILE .T.
   barstatus(7)
   SET COLOR TO W/BG+,B+/W
   STORE SPACE(8) TO clave
   marcmenu(8,15,15,65)
   SET COLOR TO W/BG+,B+/W
   SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","K")})
   @9,25 SAY "Introduzca la clave del candidato:"   
   @11,35 GET clave VALID .NOT. clave= " "
   READ
   IF LASTKEY()=27
      RETURN
   ELSE
      SELECT nombres
      GO TOP
      SEEK clave
      IF FOUND()
         candi=TRIM(nombre_s)+" "+TRIM(paterno)+" "+TRIM(materno)
         @13,25 SAY candi
         DO CASE
            CASE tipo_man ="C"
                 resp=dialogo("Candidato a modificar? S/N ")
            CASE tipo_man = "M"
                 resp=dialogo("Candidato a consultar? S/N ")
            CASE tipo_man = "O"
                 resp=dialogo("Candidato correcto? S/N ")
         ENDCASE
         IF resp="S"
            RETURN(clave)
         ELSE
            limpiamenu(17,30,21,79)
         ENDIF
      ELSE
         ponerror("Clave inexistente")
      END
   ENDIF
ENDDO


*************************************************************************
** FUNCION QUE BUSCA LOS TEST APLICABLES A UN CANDIDATO
*************************************************************************
FUNCTION busca_test(clave_candi)

USE asig_esp NEW              // nuevo
SELECT candidat
SEEK clave_candi
clave_puesto=cve_puest
SELECT asig_esp
SET FILTER TO
SET FILTER TO cve_per = clave_puesto 
COPY TO pues_tmp ALL
SET FILTER TO
SET FILTER TO tipo="T"
COPY TO test_tmp ALL 
CLOSE asig_esp        // nuevo
RETURN (clave_puesto)

*************************************************************************
** FUNCION QUE DESPLIEGA LOS TEST APLICABLES
*************************************************************************
FUNCTION desp_test(y1,x1,y2,x2)
tottest=0
DECLARE campos[2]
PRIVATE clave
SELECT testapli
SET COLOR TO W+/BG+,B+/W
GO TOP
campos[1]="cve_per"
campos[2]="catprin->nom_obj"
tottest=LASTREC()
IF tottest>=1 
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED3",;
     {"XXXXXXXX","XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"},;
     {"CLAVE","NOMBRE"},"","  ","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ENDIF
ELSE
   ponerror("El puesto no requiere test")
ENDIF
RETURN(clave)

*************************************************************************
** PROCEDIMIENTO PARA ASIGNAR LA EVALUACION DE UN CANDIDATO
*************************************************************************
PROCEDURE asig_eval_candi

USE candidat INDEX indcandi NEW
USE nombres INDEX indnombr NEW
USE catprin INDEX indprin NEW
USE e_test_c NEW
DO WHILE .T.
   clave_candi=pide_clave_candi("O")
   IF LASTKEY()=27
      RETURN
   ELSE
      barstatus(4) 
      clave_puesto=busca_test(clave_candi)
      USE pues_tmp NEW
      INDEX ON cve_esp + cve_per TO indpuetm
      USE test_tmp NEW
      INDEX ON cve_esp + cve_per TO indtestm
      JOIN WITH pues_tmp TO testapli FOR pues_tmp->cve_esp = test_tmp->cve_esp;
        FIELDS cve_per,cve_esp
      USE testapli NEW
      INDEX ON cve_per TO indtesap UNIQUE
      SET RELATION TO cve_per INTO catprin
      DO WHILE .T.
         STORE SPACE(2) TO veval_test
         acc="A"
         limpiamenu(8,5,22,79)
         SELECT testapli
         clave_test=desp_test(2,2,12,55)
         IF clave_test= NIL
            limpiamenu(1,1,14,58)
            EXIT
         ELSE
            @19,10 SAY "Resultado: " GET veval_test PICTURE "XX" VALID .NOT. veval_test =" "
            READ
            IF LASTKEY() = 27
               EXIT
            ELSE
               SELECT e_test_c
               LOCATE FOR cve_per=clave_candi .AND. cve_test=clave_test
               IF FOUND()
                  acc="M"
                  resp=dialogo("Evaluacin existe. Modificar? S/N ")
               ELSE
                  resp=dialogo("Es correcta la evaluacin? S/N ")
               ENDIF
               IF resp="S"
                  IF acc="A"
                     APPEND BLANK
                  ENDIF
                  REPLACE cve_per WITH clave_candi
                  REPLACE cve_test WITH clave_test
                  REPLACE eval_test WITH veval_test
                ENDIF
            ENDIF
         ENDIF
      ENDDO
      CLOSE pues_tmp
      CLOSE test_tmp
      CLOSE testapli
   ENDIF
ENDDO


*FUNCION PARA LA EDICION DEL DBEDIT DE LOS TEST A APLICAR
FUNCTION FUN_ED3
PARAMETERS mode,i
PUBLIC campo_sel

campo_sel:=campos[1]
DO CASE
   CASE mode = 3      && abandona la edicin por archivo vaco
        RETURN(0)
   CASE mode < 4      && continua con la edicin
        RETURN(1)  
   CASE LASTKEY()=27  && abandona la edicin por tecla ESC
        RETURN(0)
   CASE LASTKEY()=13  && obtiene la clave y la despliegua en el campo corresp.
        RETURN(0)
   CASE LASTKEY()=-4
        RETURN(0)
ENDCASE


*************************************************************************                     
** REGISTRO DE LA FUENTE DE RECLUT. POR LA CUAL SE ENTERO EL CANDIDATO
*************************************************************************
FUNCTION reg_fuente 

band=.F.
SETKEY(-1,{||cat_gral(6,3,20,56,"catprin","F")})
pantfue=SAVESCREEN(0,0,24,79)
DO WHILE band=.F.
   vcve_fue=" "
   SET COLOR TO W/BG+,B+/W
   marcmenu(10,10,18,60)
   SET COLOR TO W/BG+,B+/W
   STORE SPACE(8) TO clave
   @12,20 SAY "Fuente de reclutamiento"
   @14,12 SAY "Clave:" GET clave PICTURE "@!" VALID .NOT. clave=" "
   READ
   IF LASTKEY()= 27 
      RESTSCREEN(0,0,24,79,pantfue)
      band=.T.
      RETURN(vcve_fue)
   ELSE
      SELECT catprin
      SEEK clave
      IF .NOT. FOUND()
         ponerror("Fuente de reclutamiento inexistente")
         band=.F.
      ELSE
         nom_fuente = nom_obj
         @16,12 SAY nom_fuente
         INKEY(0)
         limpiamenu(10,10,20,62)
         RESTSCREEN(0,0,24,79,pantfue)
         band=.T.
         RETURN(clave)
      ENDIF
   ENDIF
ENDDO

