****************************************************************************
** PROCEDIMIENTO GENERAL DE SELECCION DE CANDIDATOS 
****************************************************************************
PROCEDURE sele_ext()

DO WHILE .T.
   indices()
   USE sol_pers NEW
   INDEX ON folio TO indsol
   USE catprin INDEX indprin NEW
   SET COLOR TO "W+/BG+,B+/W"
   DO WHILE .T.
      limpiamenu(2,1,22,79)
      barstatus(4)
      vfolio=sel_folio()
      IF vfolio=NIL
         CLOSE ALL
         RETURN
      ELSE
         clave_puesto=busca_datos_req(vfolio)
         resp = dialogo("Seleccin para este puesto? S/N")
         IF resp="S"
            continua = .T.
            EXIT
         ELSE
            limpiamenu(5,15,23,79)
            continua = .F.
            EXIT
         ENDIF
      ENDIF
   ENDDO
   If continua = .T.
      ejecuta = "S"
      USE selfin NEW
      LOCATE FOR folio=VAL(vfolio)
      IF FOUND()
         ponerror("Ya existen candidatos para este folio")
         ejecuta=dialogo("Desea actualizar datos? S/N")
      ELSE
         ejecuta="S"
      ENDIF
      IF ejecuta="S"
         busca_candis()
         USE pues_tmp NEW
         INDEX ON cve_per+cve_esp TO indpuetm
         totpues=RECCOUNT()
         USE cand_tmp NEW
         INDEX ON cve_per+cve_esp TO indcantm
         totcand=RECCOUNT()
         IF totpues<>0 .OR. totcand<>0      
            JOIN WITH pues_tmp TO candsels FOR pues_tmp->cve_esp = cand_tmp->cve_esp;
            FIELDS cve_per,cve_esp,valor,cve_uni
            SELECT selfin
            SET FILTER TO folio=VAL(vfolio)
            DELETE ALL
            PACK
            USE candsels NEW
            no_esp=0
            totregsel=LASTREC()
            FOR cont=1 TO totregsel
                SELECT candsels
                GOTO cont
                cve_can1=cve_per
                COUNT FOR cve_per=cve_can1 TO no_esp
                guarda_candis_sel(vfolio,cve_can1,no_esp)
            NEXT
         ENDIF
      ENDIF
      CLOSE ALL
      DO WHILE .T.
         USE selfin NEW
         INDEX ON -num_esp TO indselfi
         clave_candi=muestra_gral(4,3,19,76,vfolio,0)
         DO CASE
            CASE clave_candi = NIL
                 IF LASTKEY()=27
                    EXIT
                 ENDIF
            CASE clave_candi <> NIL
                 IF LASTKEY()=13
                    limpiamenu(3,2,22,78)
                    consulta_selec_detallada(clave_candi,clave_puesto)
                 ELSE
                    IF LASTKEY() = -4
                       clave_candi=NIL
                    ENDIF
                 ENDIF
         ENDCASE
      ENDDO
   ENDIF
ENDDO

*************************************************************************
** PROCEDIMIENTO PARA CONSULTAR EN DETALLE LAS ESPEC. DE UN CANDIDATO
*************************************************************************
PROCEDURE consulta_selec_detallada(clave_candi,clave_puesto)

USE candsels NEW
INDEX ON cve_esp TO indcasel
USE candidat INDEX indcandi NEW 
USE catprin INDEX indprin NEW
USE cand_tmp NEW
INDEX ON cve_esp TO indcantm
USE pues_tmp NEW
INDEX ON cve_esp TO indpuetm
DO WHILE .T.
   barstatus(3)
   SELECT selfin
   LOCATE FOR cve_per=clave_candi
   nomb_candi=nombre
   SELECT candidat
   SEEK clave_candi
   puesto=cve_puest
   SELECT catprin
   SEEK clave_puesto
   nomb_puesto=nom_obj
   SET COLOR TO "W+/BG+,B+/W"
   @2,5 SAY "Candidato seleccionado para el puesto: " + clave_puesto
   @4,2 SAY "Clave: " + clave_candi + " Nombre Candidato: " + nomb_candi
   @6,2 SAY "Puesto Solicitado: " + puesto + " " + nomb_puesto
   clave_det=muestra_detalle(8,4,19,73,clave_candi)
   IF clave_det=NIL
      CLOSE ALL
      RETURN
   ENDIF
ENDDO

****************************************************************************
** PROCEDIMIENTO QUE DESPLIEGA LOS CANDIDATOS SELECCIONADOS (GENERAL)
****************************************************************************
PROCEDURE muestra_gral(y1,x1,y2,x2,vfolio,tecla)

totcandis=0
DECLARE campos[5]
PUBLIC clave
clave = NIL
IF tecla = -1
   pantsel=SAVESCREEN(0,0,24,79)
ENDIF
SELECT selfin
SET FILTER TO
SET FILTER TO folio=VAL(vfolio)
SET COLOR TO W+/BG+,B+/W
limpiamenu(2,1,2,79)
barstatus(14)
campos[1]="fecha_pro"
campos[2]="STRZERO(folio,6,0)"
campos[3]="cve_per"
campos[4]="nombre"
campos[5]="STR(num_esp)"
COUNT FOR folio=VAL(vfolio) TO totcandis
IF totcandis >= 1
   limpiamenu(2,1,2,79)
   GO TOP
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED4",;
     {"99-99-99","XXXXXX","XXXXXXXX","XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",""},;
     {"PROCESO","FOLIO REQ.","IDENTIF.","NOMBRE CANDIDATO","N ESP."},"","","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ELSE
     IF (LASTKEY()=-4)
        marcmenu(11,21,13,49)
        SET COLOR TO "W+/BG+,B+/W"
        @12,26 SAY "IMPRIMIENTO REPORTE..."
        REPORT FORM selext TO PRINT NOCONSOLE
        limpiamenu(11,21,15,51)
        clave=NIL
     ENDIF
   ENDIF
ELSE
   ponerror("No hay candidatos para el puesto")
   clave=NIL
ENDIF
IF tecla = -1
   limpiamenu(y1,x1,y2+2,x2+2)
   RESTSCREEN(0,0,24,79,pantsel)
ENDIF
RETURN(clave)


****************************************************************************
** PROCEDIMIENTO QUE GUARDA LOS DATOS DE LOS CANDIDATOS SELECCIONADOS
****************************************************************************
PROCEDURE guarda_candis_sel(vfolio,cve_can1,no_esp)     

SELECT selfin
LOCATE FOR folio=VAL(vfolio) .AND. cve_per=cve_can1
IF .NOT. FOUND()
   USE nombres INDEX indnombr NEW
   SEEK cve_can1
   IF FOUND()
      nom_candi=TRIM(paterno) + " " + TRIM(materno) + " " + TRIM(nombre_s)
   ELSE
      nom_candi=" "
   ENDIF
   CLOSE nombres
   SELECT selfin
   APPEND BLANK 
   REPLACE fecha_pro WITH DATE()
   REPLACE folio WITH VAL(vfolio)
   REPLACE cve_per WITH cve_can1
   REPLACE nombre WITH nom_candi
   REPLACE num_esp WITH no_esp
   RETURN
ENDIF


****************************************************************************
***PROCEDIMIENTO QUE SELECCIONA LAS ESPECIFICACIONES DEL PUESTO SELECCIONADO
*** Y LOS CANDIDATOS EXISTENTES
****************************************************************************

PROCEDURE busca_candis()

USE asig_esp NEW       // nuevo
SET FILTER TO
SET FILTER TO cve_per = clave_puesto
COPY TO pues_tmp ALL
SET FILTER TO
SET FILTER TO tipo="K"
COPY TO cand_tmp ALL
CLOSE asig_esp         // nuevo
RETURN
   


****************************************************************************
***FUNCION QUE PERMITE SELECCIONAR UN FOLIO DE UNA REQUISICION DE PERS.
****************************************************************************
FUNCTION sel_folio()

SELECT sol_pers
totreg = reccount()
IF totreg = 0
   ponerror("Requisiciones de personal inexistentes")
   CLOSE ALL
   RETURN
ELSE
   regreq = ARRAY(totreg)
   @2,1 SAY "FOLIOS REGISTRADOS"
   vfolio = despfolios(4,5,12,12,@regreq,totreg)
   IF LASTKEY()=27
      CLOSE ALL
      RETURN
   ELSE
      RETURN(vfolio)
   ENDIF
ENDIF

****************************************************************************
***FUNCION QUE PERMITE SELECCIONAR UN FOLIO DE UNA REQUISICION DE PERS.
****************************************************************************
FUNCTION busca_datos_req(vfolio)    

SEEK vfolio
IF FOUND()
   area=clave_area
   puesto=clave_pues
   personal=per_requer
   SELECT catprin
   SEEK puesto
   IF FOUND()
      nom_puesto=nom_obj
   ELSE
      nom_puesto=" "
   ENDIF
   SEEK area
   IF FOUND()
      nom_area=nom_obj
   ELSE 
      nom_area=" "
   ENDIF
   @5,15 SAY "Folio de Requisicin de Personal seleccionado: "+vfolio
   @7,15 SAY "Clave del puesto: " + puesto 
   @9,15 SAY "Puesto: " + nom_puesto
   @11,15 SAY "Clave del area: " + area 
   @13,15 SAY "Area: " + nom_area 
   CLOSE sol_pers           // nuevo
   CLOSE catprin            // nuevo
   RETURN(puesto)
ENDIF


****************************************************************************
*FUNCION QUE DESPLIEGA LOS FOLIOS DE LAS REQUISICIONES DE PERSONAL
****************************************************************************
FUNCTION despfolios
PARAMETERS y1,x1,y2,x2,arreglo,nrec

GO TOP
FOR i=1 TO nrec
    arreglo[i]=STRZERO(folio,6,0)
    SKIP
NEXT
DO WHILE .T.
   marcmenu(y1,x1,y2,x2,"B/W+,W+/B+")
   ASORT(arreglo)
   reg=ACHOICE(y1+1,x1+1,y2-1,x2-1,arreglo,"","valida")
   sel=arreglo[reg]
   SET COLOR TO W+/BG+,B+/W
   RETURN(sel)
ENDDO   

****************************************************************************
** PROCEDIMIENTO QUE DESPLIEGA LOS CANDIDATOS SELECCIONADOS (DETALLADO)
****************************************************************************
PROCEDURE muestra_detalle(y1,x1,y2,x2,clave_candi)
totcandis=0
DECLARE campos[5]
PRIVATE clave
clave = NIL
SELECT candsels
SET RELATION TO cve_esp INTO pues_tmp
SET FILTER TO
SET FILTER TO cve_per=clave_candi
SET COLOR TO W+/BG+,B+/W
campos[1]="pues_tmp->cve_esp"
campos[2]="pues_tmp->valor"
campos[3]="pues_tmp->cve_uni"
campos[4]="cand_tmp->valor"
campos[5]="cand_tmp->cve_uni"
COUNT FOR cve_per=clave_candi TO totcandis
IF totcandis >= 1
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   GO TOP                  
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED3",;
     {"XXXXXXXX","9999.99","XXXXXXXX","9999.99","XXXXXXXX"},;
     {"CLAVE ESP.","VALOR PUESTO","MEDIDA","VALOR CAND.","MEDIDA"},"","","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ELSE
      IF (LASTKEY()=-4)
          marcmenu(11,21,13,49)
          SET COLOR TO "W+/BG+,B+/W"
          @12,26 SAY "IMPRIMIENTO REPORTE..."
          REPORT FORM seldetex TO PRINT NOCONSOLE
          limpiamenu(11,21,15,51)
          clave = NIL
      ENDIF
   ENDIF
ELSE
   ponerror("No hay candidatos para el puesto")
   clave=NIL
ENDIF
RETURN(clave)

****************************************************************************
*FUNCION PARA LA EDICION DEL DBEDIT DE LOS CANDIDATOS SELECCIONADOS
****************************************************************************
FUNCTION FUN_ED4
PARAMETERS mode,i
PUBLIC campo_sel

campo_sel:=campos[3]
DO CASE
   CASE mode = 3      && abandona la edicin por archivo vaco
        RETURN(0)
   CASE mode < 4      && continua con la edicin
        RETURN(1)  
   CASE LASTKEY()=27  && abandona la edicin por tecla ESC
        RETURN(0)
   CASE LASTKEY()=13  && obtiene la clave y la despliegua en el campo corresp.
        RETURN(0)
   CASE LASTKEY()=-4  && obtiene la clave 
        RETURN(0)
ENDCASE


